/***************************************************************************
                          general.cpp  -  description
                             -------------------
    begin                : Sat Mar 18 2000
    copyright            : (C) 2000 by Christian Rossi
    email                : crossi@mailcity.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
/***************************************************************************
                          general.cpp  -  description                              
                             -------------------                                         
    begin                : Sat Jul 10 1999                                           
    copyright            : (C) 1999 by Christian Rossi                         
    email                : crossi@mailcity.com                                     
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   * 
 *                                                                         *
 ***************************************************************************/
#include <unistd.h>
#include <stdio.h>
#define MY_DEBUG

int pipe_pgp(const char *cmd, FILE **in, FILE **out,FILE **error)
{
         int pin[2], pout[2],perror[2], child_pid;

#ifdef MY_DEBUG
			   printf("pipe_pgp DEBUG: %s\n",cmd);
#endif
         *in = *out = *error = NULL;

         pipe(pin);
         pipe(pout);
				 pipe(perror);

         if(!(child_pid = fork()))
         {
           // We're the child.
           close(pin[1]);
           dup2(pin[0], 0);
           close(pin[0]);

           close(pout[0]);
           dup2(pout[1], 1);
           close(pout[1]);

           close(perror[0]);
           dup2(perror[1], 2);
           close(perror[1]);

           execl("/bin/sh", "sh", "-c", cmd, NULL);
           _exit(127);
         }

         // Only get here if we're the parent.
         close(pout[1]);
         *out = fdopen(pout[0], "r");

         close(perror[1]);
         *error = fdopen(perror[0], "r");

         close(pin[0]);
         *in = fdopen(pin[1], "w");

         return(child_pid);
}

