/***************************************************************************
                          kdlggrupos.cpp  -  description
                             -------------------
    begin                : Sun Apr 30 2000
    copyright            : (C) 2000 by Christian Rossi
    email                : crossi@mailcity.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
#include "kdlggrupos.h"
#include "kpgpcrypt.h"
#include <stdlib.h>


extern KPGPCrypt	*Ventana;

KDlgGrupos::KDlgGrupos(QWidget *parent, const char *name,bool nuevo,char grupo[255]): QDialog(parent,name,true)
{
	tipoOperacion = nuevo;
	strcpy(grupoActual,grupo);
	
	initDialog();
	switch (tipoOperacion)
	{
		// Seteo los controles del Dialogo para el caso
		// en que se este creando un grupo nuevo
		case true:
			m_Grupo->show();
			m_ListaLlaves->hide();
			break;
		
		// Seteo los controles del Dialogo para el caso
		// en que se esten agregando llaves a un grupo existente
		case false:
			m_Grupo->hide();
			m_ListaLlaves->show();
			break;
	}

	inicializarDialog();
		
	connect(m_Aceptar,SIGNAL(released()),this,SLOT(slotOk()));
	connect(m_cancelar,SIGNAL(released()),this,SLOT(slotCancel()));
}

KDlgGrupos::~KDlgGrupos()
{
}

/**  */
void KDlgGrupos::slotOk()
{
	char	mandato[256];

	switch (tipoOperacion)
	{
		// Se esta agregando un grupo nuevo
		case true:
			strcpy(mandato,"kvt -no_menubar -no_scrollbar -e pgp60 -ga \"");
			strcat(mandato,m_Grupo->text());
			strcat(mandato,"\"");
			system(mandato);
			break;
		// Se estan agregando llaves a un grupo ya existente
		case false:
			strcpy(mandato,"kvt -no_menubar -no_scrollbar -e pgp60 -ga \"");
			strcat(mandato,grupoActual);
			strcat(mandato,"\" \"");
			strcat(mandato,m_ListaLlaves->currentText());
			strcat(mandato,"\"");
			system(mandato);
			break;
	}
	Ventana->leerGrupos();
	Ventana->view->tw->llenarGrupos();
}

/**  */
void KDlgGrupos::slotCancel()
{
	hide();
	return;
}
/**  */
void KDlgGrupos::inicializarDialog()
{
	int	i;
	switch (tipoOperacion)
	{
		// Se esta agregando un grupo nuevo
		case true:
			return;		
			break;
		// Se estan agregando llaves a un grupo ya existente
		case false:
			for (i=0;i <= Ventana->ListaLlaves.CantidadDeLlaves;i++)
			{
				if (!Ventana->ListaLlaves.Llaves[i].Secreta)
				{
					m_ListaLlaves->insertItem(Ventana->ListaLlaves.Llaves[i].Nombre);
				}
			}
			break;
	}
}
