/***************************************************************************
                          kkeyserver.cpp  -  description
                             -------------------
    begin                : Sat May 6 2000
    copyright            : (C) 2000 by Christian Rossi
    email                : crossi@mailcity.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
#include "kkeyserver.h"
#include "kpgpcrypt.h"
#include <stdio.h>
#include <stdlib.h>
#include <netdb.h>
#include <netinet/in.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <assert.h>
#include <qfile.h>

extern FILE *stderr;
extern FILE *stdout;
extern int pipe_pgp(const char *cmd, FILE **in, FILE **out,FILE **error);
extern KPGPCrypt *Ventana;

KKeyServer::KKeyServer(QWidget *parent, const char *name) : QDialog(parent,name,true)
{
	initDialog();

	m_HTML = new QTextBrowser(this);
	m_HTML->setGeometry(10,110,700,240);
	
	connect(m_Salir,SIGNAL(released ()),SLOT(slotSalir()));	
	connect(m_Buscar,SIGNAL(released ()),SLOT(slotBuscar()));	
	connect(m_Traer,SIGNAL(released ()),SLOT(slotTraer()));	
	connect(m_Agregar,SIGNAL(released ()),SLOT(slotAgregar()));	
	connect(m_Copiar,SIGNAL(released ()),SLOT(slotCopiar()));	
	connect(m_Seleccionar,SIGNAL(released ()),SLOT(slotSeleccionar()));	

				
	m_host->setText("localhost");
	m_llave->setText("");
}

KKeyServer::~KKeyServer(){
}

void KKeyServer::slotSalir()
{
	hide();
}
/************************
 * Comienza la busqueda *
 ************************/
void KKeyServer::slotBuscar()
{
	char	*Buffer = NULL;
	char	*userID = NULL;

	Buffer = new char[10240];
	userID = new char[1024];

	userID = m_llave->text();
		
	GetKeyInfoHkp(m_host->text(),(unsigned short)11371,&Buffer,userID,BUSCAR);
	m_HTML->setText(Resultado);
}

int KKeyServer::GetKeyInfoHkp(char *keyserver,unsigned short port,char **KeyBuffer,char *UserId,bool funcion)
{

	struct hostent *pHostEnt=NULL;
  struct sockaddr_in server_info;
  struct in_addr ip;
  int sockfd;
  char buffer[8192];
  int ReturnCode = 0;

	m_Log->clear();
	m_Log->insertLine("BUSCANDO AL SERVIDOR");
	
  if((pHostEnt = gethostbyname(keyserver)))
  {
		m_Log->insertLine("ESTABLECIENDO COMUNICACION CON EL SERVIDOR");
		memcpy(&ip, pHostEnt->h_addr, sizeof(ip));
		server_info.sin_addr = ip;
		server_info.sin_port = htons(port);
		server_info.sin_family = pHostEnt->h_addrtype;

			if((sockfd = socket(server_info.sin_family, SOCK_STREAM, 0)) >= 0)
			{
	  	  if(!__connect(sockfd,(struct sockaddr *) & server_info,sizeof(server_info)))
	    	{
					m_Log->insertLine("ENVIANDO PEDIDO DE INFORMACION");

					if (funcion == TRAER)
						sprintf(buffer,"GET /pks/lookup?&op=get&exact=on&search=%s HTTP/1.0\n",UserId);
					else if (funcion == BUSCAR)
					{
						sprintf(buffer,"GET /pks/lookup?&search=%s",UserId);
						
						if (m_Fingerprint->isChecked())	
							strcat(buffer,"&Fingerprint=on");
						if (m_Exacta->isChecked())	
							strcat(buffer,"&exact=on");
						if (m_Verbose->isChecked())	
							strcat(buffer,"&op=vindex HTTP/1.0\n");
						else	
							strcat(buffer,"&op=index HTTP/1.0\n");
					}
										
					strcat(buffer, "User-Agent: PGP/6.51 (Unix)\n\r\n\r");
					send(sockfd, buffer, strlen(buffer), 0);
					m_Log->insertLine("RECIBIENDO DATOS DE LAS LLAVES");
   				ReturnCode = ReceiveBuffer(KeyBuffer, sockfd);
					m_Log->insertLine("LIMPIANDO");

					if(ReturnCode == 0)
					{
		  			m_Log->insertLine("TRANSFERENCIA DE INFORMACION COMPLETA");
					}
		    }
	  	  else
	  	  {
		  	  m_Log->insertLine("NO SE PUEDE ESTABLECER COMUNICACION CON EL SERVIDOR");
					ReturnCode = ERR_UNABLE_TO_OPEN_SOCKET;
				}
		    // close(sockfd);
			}
			else
		    ReturnCode = ERR_UNABLE_TO_OPEN_SOCKET;
	  }
  	else
			ReturnCode = ERR_HOST_NOT_FOUND;
	
	return(0);
}

unsigned long KKeyServer::ReceiveBuffer(char **buffer,int sockfd)
{
	unsigned long CharsReceived = 0, ReturnCode = 0;
  char TempBuffer[256];

  assert(buffer);

  *buffer = NULL;
	Resultado = "";
  do
  {
		CharsReceived = recv(sockfd, TempBuffer, sizeof(TempBuffer) - 1, 0);

		if(CharsReceived)
		{
			*(TempBuffer + CharsReceived) = '\0';
			QString aaa = TempBuffer;

			aaa = aaa.right(CharsReceived - aaa.find("<title>",0,TRUE));			
			Resultado.operator+=(aaa);
		}
	}while(CharsReceived);

  return(ReturnCode);
}/**  */
void KKeyServer::slotTraer()
{
	char	*Buffer = NULL;
	char	*userID = NULL;

	Buffer = new char[10240];
	userID = new char[1024];

	userID = m_llave->text();
		
	GetKeyInfoHkp(m_host->text(),(unsigned short)11371,&Buffer,userID,TRAER);
	m_HTML->setText(Resultado);	
}

/**  */
void KKeyServer::slotAgregar()
{
	QString	Llaves;
	char		buffer[256];
	
	
	strcpy(buffer,(const char *)getenv("HOME"));	
	strcat(buffer,"/.pgp/4261324.txt");
	Llaves = m_HTML->text();
	QFile	File(buffer);
	File.open(IO_WriteOnly);
	File.writeBlock(Llaves,Llaves.length());
	File.close();
	
	if (operator==(Ventana->Version(),"PGP 5.00"))
		strcpy(buffer,"kvt -no_menubar -no_scrollbar -e pgpk -a ")	;
	else if (operator==(Ventana->Version(),"PGP 6.51"))
		strcpy(buffer,"kvt -no_menubar -no_scrollbar -e pgp60 -ka ")	;
	else if (operator==(Ventana->Version(),"GNUPG 1.00"))
		strcpy(buffer,"gpg --import ")	;
	
	strcat(buffer,(const char *)getenv("HOME"));	
	strcat(buffer,"/.pgp/4261324.txt");
	system(buffer);
	File.remove();
}

/**  */
void KKeyServer::slotCopiar()
{
//	((QTextView *)(m_HTML))->copy();
}

/**  */
void KKeyServer::slotSeleccionar()
{
//	((QTextView *)(m_HTML))->selectAll();
}
