/***************************************************************************
                          kkeyserver.h  -  description
                             -------------------
    begin                : Sat May 6 2000
    copyright            : (C) 2000 by Christian Rossi
    email                : crossi@mailcity.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef KKEYSERVER_H
#define KKEYSERVER_H

//Generated area. DO NOT EDIT!!!(begin)
#include <qwidget.h>
#include <qbuttongroup.h>
#include <qlabel.h>
#include <qlineedit.h>
#include <qmultilinedit.h>
#include <qpushbutton.h>
#include <qcheckbox.h>
//Generated area. DO NOT EDIT!!!(end)

#include <qdialog.h>
#include <qtextbrowser.h>

#define KS_ERR_BASE                             4000

#define ERR_UNABLE_TO_LOAD_LIBRARY							KS_ERR_BASE + 0
#define ERR_NO_FUNCS_AVAILABLE									KS_ERR_BASE + 1
#define ERR_LIBRARY_NOT_LOADED									KS_ERR_BASE + 2
#define ERR_BAD_PARAM														KS_ERR_BASE + 3
#define ERR_FUNCTION_NOT_IN_LIB									KS_ERR_BASE + 4
#define	ERR_USER_NOT_FOUND											KS_ERR_BASE + 5
#define ERR_USER_CANCEL													KS_ERR_BASE + 6
#define	ERR_KEYRING_FAILURE											KS_ERR_BASE + 7
#define	ERR_MALLOC_FAILURE											KS_ERR_BASE + 8
#define ERR_DATA_WAIT_TIMEOUT										KS_ERR_BASE + 9
#define ERR_SOCKET_ERROR												KS_ERR_BASE + 10
#define ERR_NO_MEM          							      KS_ERR_BASE + 11
#define ERR_HOST_NOT_FOUND											KS_ERR_BASE + 12
#define ERR_UNABLE_TO_OPEN_SOCKET								KS_ERR_BASE + 13
#define ERR_MANY_NOT_FOUND											KS_ERR_BASE + 14
#define ERR_NO_RESPONSE_FROM_SERVER							KS_ERR_BASE + 15

#define	TRAER																		1
#define	BUSCAR																	0

/**
  *@author Christian Rossi
  */

class KKeyServer : public QDialog  {
   Q_OBJECT
public: 
	KKeyServer(QWidget *parent=0, const char *name=0);
	~KKeyServer();
  /**  */
  int GetKeyInfoHkp(char *keyserver,unsigned short port,char **KeyBuffer,char *UserId,bool funcion);
	unsigned long KKeyServer::ReceiveBuffer(char **buffer,int sockfd);


protected: 
public: // Public attributes
  /**  */
  QTextBrowser *m_HTML;
	void initDialog();
	//Generated area. DO NOT EDIT!!!(begin)
	QButtonGroup *QButtonGroup_1;
	QLabel *QLabel_7;
	QLineEdit *m_host;
	QLineEdit *m_llave;
	QMultiLineEdit *m_Log;
	QPushButton *m_Agregar;
	QPushButton *m_Salir;
	QLabel *QLabel_1;
	QLabel *QLabel_2;
	QPushButton *m_Buscar;
	QPushButton *m_Traer;
	QLabel *QLabel_5;
	QLabel *QLabel_6;
	QPushButton *m_Seleccionar;
	QPushButton *m_Copiar;
	QCheckBox *m_Verbose;
	QCheckBox *m_Exacta;
	QCheckBox *m_Fingerprint;
	//Generated area. DO NOT EDIT!!!(end)

  /**  */
  QString Resultado;
	
private:
public slots: // Public slots
  /**  */
  void slotSalir();
  /**  */
  /**  */
  void slotSeleccionar();
  /**  */
  void slotCopiar();
  void slotTraer();
  /************************
	 * Comienza la busqueda *
	 ************************/
  void slotBuscar();
  /**  */
  void slotAgregar();
};

#endif
