/***************************************************************************
                          kpgpcrypt.cpp  -  description
                             -------------------
    begin                : Sat Mar 18 15:48:07 ART 2000
    copyright            : (C) 2000 by Christian Rossi
    email                : crossi@mailcity.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include <stdlib.h>
#include <qconfig.h>
#include <qprogressdialog.h>
#include <kmsgbox.h>
#include <kdlgcreatekey.h>
#include <kdlgreceptores.h>
#include <kdlgpassword.h>
#include <qfiledialog.h>
#include <qcombobox.h>
#include <qprogressdialog.h>

#include "general.h"
#include "kllaves.h"
#include "kpgpcrypt.h"
#include "kdlggrupos.h"
#include "kkeyserver.h"
#include "kdlgabout.h"
#include "kdlghelp.h"
#include "kconfigdlg.h"

extern FILE *stderr;
extern FILE *stdout;
extern KPGPCrypt *Ventana;

KPGPCrypt::KPGPCrypt()
{

  Ventana = this;


  ///////////////////////////////////////////////////////////////////
  // call inits to invoke all other construction parts
  initMenuBar();
  initStatusBar();
  initToolBar();
  initDoc();
	initDatos();
  initView();

  actualizaBotones();

  setGeometry(0,0,800,600);
  setCaption("PGPCrypt V 2.0.0");	
}

KPGPCrypt::~KPGPCrypt()
{
}

void KPGPCrypt::initMenuBar()
{
  ///////////////////////////////////////////////////////////////////
  // MENUBAR

  ///////////////////////////////////////////////////////////////////
  // menuBar entry viewMenu
  viewMenu=new QPopupMenu();
  viewMenu->setCheckable(true);
  viewMenu->insertItem("Tool&bar", this, SLOT(slotViewToolBar()), 0, ID_VIEW_TOOLBAR);
  viewMenu->insertItem("&Statusbar", this, SLOT(slotViewStatusBar()), 0, ID_VIEW_STATUSBAR);

  viewMenu->setItemChecked(ID_VIEW_TOOLBAR, true);
  viewMenu->setItemChecked(ID_VIEW_STATUSBAR, true);

  ///////////////////////////////////////////////////////////////////
  // EDIT YOUR APPLICATION SPECIFIC MENUENTRIES HERE

	fileMenu 		= new QPopupMenu();
	fileMenu->insertItem("&Abrir",this, SLOT(slotAbrir()),0);
	fileMenu->insertItem("&Guardar",this, SLOT(slotGuardar()),0);
	fileMenu->insertItem("G&uardar Config",this, SLOT(slotGuardarConfig()),0);
	fileMenu->insertSeparator();
	fileMenu->insertItem("&Salir",this, SLOT(slotSalir()),0);
	
	editMenu 		= new QPopupMenu();
	editMenu->insertItem("&Copiar",this, SLOT(slotCopy()),0);
	editMenu->insertItem("C&ortar",this, SLOT(slotCut()),0);
	editMenu->insertItem("&Pegar",this, SLOT(slotPaste()),0);
	editMenu->insertSeparator();
	editMenu->insertItem("&Actualizar",this, SLOT(slotActualizar()),0);
	
	keysMenu 		 = new QPopupMenu();
	keysMenu->insertItem("&Crear nueva llave",this, SLOT(slotCrearLlave()),0);
	keysMenu->insertItem("&Borrar llave",this, SLOT(slotBorrarLlave()),0);
	keysMenu->insertItem("&Firmar Llave",this, SLOT(slotFirmarLlave()),0);
	keysMenu->insertItem("&Activar / Desactivar llave",this, SLOT(slotActivarLlave()),0);
	keysMenu->insertItem("&Importar",this, SLOT(slotImportarLlave()),0);
	keysMenu->insertItem("&Exportar",this, SLOT(slotExportarLlave()),0);
	keysMenu->insertItem("&Servidor de Llaves",this, SLOT(slotTraerLlave()),0);
		
	messagesMenu = new QPopupMenu();
	messagesMenu->insertItem("&Borrar Editor",this, SLOT(slotLimpiar()),0);
	messagesMenu->insertItem("&Encriptar",this, SLOT(slotEncriptar()),0);
	messagesMenu->insertItem("&Firmar",this, SLOT(slotFirmar()),0);
	messagesMenu->insertItem("F&irmar + Encriptar",this, SLOT(slotEncriptarFirmar()),0);
	messagesMenu->insertItem("&Verificar",this, SLOT(slotVerificar()),0);

	pgpMenu = new QPopupMenu();
	pgpMenu->insertItem("PGP &5.00",this, SLOT(slotPGP500Menu()),0,IDM_PGP500);
	pgpMenu->insertItem("PGP &6.51",this, SLOT(slotPGP651Menu()),0,IDM_PGP651);
	pgpMenu->insertItem("&GNUPG 1.00",this, SLOT(slotGPG100Menu()),0,IDM_GPG100);
	pgpMenu->insertSeparator();
	pgpMenu->insertItem("&Configuracion",this, SLOT(slotConfig()),0);
	
  ///////////////////////////////////////////////////////////////////
  // menuBar entry helpMenu
  helpMenu=new QPopupMenu();
  helpMenu->insertItem("Help",this, SLOT(slotHelp()),0);
	helpMenu->insertSeparator();
  helpMenu->insertItem("About...", this, SLOT(slotHelpAbout()), 0, ID_HELP_ABOUT);


  ///////////////////////////////////////////////////////////////////
  // MENUBAR CONFIGURATION
  // set menuBar() the current menuBar 

  menuBar()->insertItem("&Archivo", fileMenu);
  menuBar()->insertItem("&Edicion", editMenu);
  menuBar()->insertItem("&Llaves", keysMenu);
  menuBar()->insertItem("&Mensajes", messagesMenu);
  menuBar()->insertItem("&PGP", pgpMenu);
  menuBar()->insertItem("&Ver", viewMenu);
  menuBar()->insertSeparator();
  menuBar()->insertItem("&Help", helpMenu);
  
  ///////////////////////////////////////////////////////////////////
  // CONNECT THE SUBMENU SLOTS WITH SIGNALS

  connect(viewMenu, SIGNAL(highlighted(int)), SLOT(statusCallback(int)));
  connect(helpMenu, SIGNAL(highlighted(int)), SLOT(statusCallback(int)));
}

void KPGPCrypt::initToolBar()
{

  ///////////////////////////////////////////////////////////////////
  // TOOLBAR
  QPixmap guardarConfigIcon,salirIcon,actualizarIcon,firmarIcon,encriptarIcon;
  QPixmap crearLlaveIcon,borrarLlaveIcon,firmarLlaveIcon,encriptarFirmarIcon,verificarIcon;
  QPixmap importarLlaveIcon,exportarLlaveIcon,copyIcon,cutIcon,pasteIcon,openIcon,saveAllIcon;
  QPixmap limpiarIcon,nuevoGrupoIcon,borrarGrupoIcon,agregarLlaveGrupoIcon,borrarLlaveGrupoIcon;
	QPixmap activarLlaveIcon,desactivarLlaveIcon,traerLlaveIcon;

  fileToolbar = new QToolBar(this, "file operations");
  QToolBar *infoToolBar = new QToolBar(this, "file operations");

  fileToolbar->setMinimumSize(22,22);

	QString base = getenv("HOME");
	QString path = base + "/.kpgpcrypt/icons/new.xpm";
	limpiarIcon =  QPixmap(path);
  QToolButton *limpiar = new QToolButton(limpiarIcon, "Limpia el editor", 0, this,
                                          SLOT(slotLimpiar()), fileToolbar);
	
	path = base + "/.kpgpcrypt/icons/open.xpm";
	openIcon =  QPixmap(path);
  QToolButton *open = new QToolButton(openIcon, "Abre un archivo de texto en el editor", 0, this,
                                          SLOT(slotAbrir()), fileToolbar);
	
	path = base + "/.kpgpcrypt/icons/save_all.xpm";
 	saveAllIcon =  QPixmap(path);
  QToolButton *saveAll = new QToolButton(saveAllIcon, "Guarda el contenido del Editor a un archivo", 0, this,
                                          SLOT(slotGuardar()), fileToolbar);

	path = base + "/.kpgpcrypt/icons/guardar-config.xpm";
  guardarConfigIcon = QPixmap(path);
  QToolButton *guardarConfig = new QToolButton(guardarConfigIcon, "Guarda la configuracin del PGP", 0, this,
                                          SLOT(slotGuardarConfig()), fileToolbar);
                                          	
	fileToolbar->addSeparator();
	
	path = base + "/.kpgpcrypt/icons/copy.xpm";
	copyIcon =  QPixmap(path);
  QToolButton *copy = new QToolButton(copyIcon, "Copia el texto marcado en el editor al portapapeles", 0, this,
                                          SLOT(slotCopy()), fileToolbar);

	path = base + "/.kpgpcrypt/icons/cut.xpm";                                          	
	cutIcon =  QPixmap(path);
  QToolButton *	cut = new QToolButton(	cutIcon, "Copia el texto marcado en el editor y lo manda al  portapapeles", 0, this,
                                          SLOT(slotCut()), fileToolbar);

	path = base + "/.kpgpcrypt/icons/paste.xpm";
 	pasteIcon =  QPixmap(path);
  QToolButton *paste = new QToolButton(pasteIcon, "Pega en el editor el contenido del portapapeles", 0, this,
                                          SLOT(slotPaste()), fileToolbar);

	path = base + "/.kpgpcrypt/icons/refresh.xpm";
  actualizarIcon = QPixmap(path);
  QToolButton *actualizar = new QToolButton(actualizarIcon, "Actualiza la Pantalla", 0, this,
                                          SLOT(slotActualizar()), fileToolbar);

	fileToolbar->addSeparator();                                          	

	path = base + "/.kpgpcrypt/icons/encriptar.xpm";		
	encriptarIcon = QPixmap(path);
  QToolButton *encriptar = new QToolButton(encriptarIcon, "Encripta un Mensaje o archivo", 0, this,
                                          SLOT(slotEncriptar()), fileToolbar);

	path = base + "/.kpgpcrypt/icons/firmar.xpm";                                          	
	firmarIcon = QPixmap(path);
  QToolButton *firmar = new QToolButton(firmarIcon, "Firma un Mensaje o archivo", 0, this,
                                          SLOT(slotFirmar()), fileToolbar);

	path = base + "/.kpgpcrypt/icons/encriptarfirmar.xpm";                                          	
	encriptarFirmarIcon = QPixmap(path);
  QToolButton *encriptarFirmar = new QToolButton(	encriptarFirmarIcon, "Encripta y Firma un Mensaje o archivo", 0, this,
                                          SLOT(slotEncriptarFirmar()), fileToolbar);


	path = base + "/.kpgpcrypt/icons/verificar.xpm";                                          	
	verificarIcon = QPixmap(path);
  QToolButton *verificar = new QToolButton(	verificarIcon, "Verifica o Verifica y Desencripta un Mensaje o archivo", 0, this,
                                          SLOT(slotVerificar()), fileToolbar);

	fileToolbar->addSeparator();

	path = base + "/.kpgpcrypt/icons/crearllave.xpm";				
	crearLlaveIcon = QPixmap(path);
  crearLlave = new QToolButton(crearLlaveIcon, "Crea una nueva llave", 0, this,
                                          SLOT(slotCrearLlave()), fileToolbar);

	path = base + "/.kpgpcrypt/icons/borrarllave.xpm";
	borrarLlaveIcon =  QPixmap(path);
  borrarLlave = new QToolButton(borrarLlaveIcon, "Borra una llave existente", 0, this,
                                          SLOT(slotBorrarLlave()), fileToolbar);

	path = base + "/.kpgpcrypt/icons/firmarllave.xpm";
	firmarLlaveIcon = QPixmap(path);
  firmarLlave = new QToolButton(firmarLlaveIcon, "Firmar una llave existente una nueva llave", 0, this,
	                                        SLOT(slotFirmarLlave()), fileToolbar);
	
	path = base + "/.kpgpcrypt/icons/importarllave.xpm";	
	importarLlaveIcon = QPixmap(path);
  importarLlave = new QToolButton(importarLlaveIcon, "Importa una llave desde un archivo", 0, this,
	                                        SLOT(slotImportarLlave()), fileToolbar);

	path = base + "/.kpgpcrypt/icons/exportarllave.xpm";		                                        	
	exportarLlaveIcon =  QPixmap(path);
  exportarLlave = new QToolButton(exportarLlaveIcon, "Exporta una llave existente", 0, this,
																          SLOT(slotExportarLlave()), fileToolbar);

	path = base + "/.kpgpcrypt/icons/activarllave.xpm";																	
  activarLlaveIcon = QPixmap(path);
  activarLlave = new QToolButton(activarLlaveIcon, "Activa una llave", 0, this,
	                                        SLOT(slotActivarLlave()), fileToolbar);

	path = base + "/.kpgpcrypt/icons/kserver.xpm";		
  traerLlaveIcon =  QPixmap(path);
  traerLlave = new QToolButton(traerLlaveIcon, "Traer una llave desde un servidor de llaves de WWW", 0, this,
                                     SLOT(slotTraerLlave()), fileToolbar);

	
	fileToolbar->addSeparator();


	path = base + "/.kpgpcrypt/icons/kpgpk-exit.xpm";				
  salirIcon = QPixmap(path);
  QToolButton *salir = new QToolButton(salirIcon, "Sale del programa", 0, this,
                                          SLOT(slotSalir()), fileToolbar);

                                        	
	fileToolbar->addSeparator();

	path = base + "/.kpgpcrypt/icons/nuevogrupo.xpm";	
  nuevoGrupoIcon =  QPixmap(path);
	nuevoGrupo = new QToolButton(nuevoGrupoIcon, "Crea un nuevo grupo", 0, this,
                               SLOT(slotNuevoGrupo()), infoToolBar);

	path = base + "/.kpgpcrypt/icons/borrargrupo.xpm";	
  borrarGrupoIcon =  QPixmap(path);
	borrarGrupo = new QToolButton(borrarGrupoIcon, "Borra un grupo con todo su contenido", 0, this,
                                SLOT(slotBorrarGrupo()), infoToolBar);

	path = base + "/.kpgpcrypt/icons/agregarllavegrupo.xpm";	
  agregarLlaveGrupoIcon =  QPixmap(path);
	agregarLlaveGrupo = new QToolButton(agregarLlaveGrupoIcon, "Agraga una llave a un grupo", 0, this,
                                      SLOT(slotAgregarLlaveGrupo()), infoToolBar);

	path = base + "/.kpgpcrypt/icons/borrarllavegrupo.xpm";	
  borrarLlaveGrupoIcon =  QPixmap(path);
  borrarLlaveGrupo = new QToolButton(borrarLlaveGrupoIcon, "Borra una llave de un grupo", 0, this,
                                     SLOT(slotBorrarLlaveGrupo()), infoToolBar);

	infoToolBar->addSeparator();

	QLabel *Label1 = new QLabel(infoToolBar,"");
	Label1->setText("Version de PGP  ");
	versionPGP = new QComboBox(infoToolBar,"aaa");
	versionPGP->insertItem("PGP 5.00");
	versionPGP->insertItem("PGP 6.51");
	versionPGP->insertItem("GNUPG 1.00");

	
	infoToolBar->addSeparator();	
	QLabel *Label2 = new QLabel(infoToolBar,"");
	Label2->setText("Llave firmante  ");
	llaveDefault = new QComboBox(infoToolBar,"");

	
	QWhatsThis::whatsThisButton(fileToolbar);
  QWhatsThis::add(guardarConfig,"Guarda la configuracin del PGP");
  QWhatsThis::add(salir,"Sale del programa");
  QWhatsThis::add(salir,"");
  QWhatsThis::add(actualizar,"");
  QWhatsThis::add(firmar,"");
  QWhatsThis::add(encriptar,"");
  QWhatsThis::add(crearLlave,"");
  QWhatsThis::add(borrarLlave,"");
  QWhatsThis::add(firmarLlave,"");
  QWhatsThis::add(encriptarFirmar,"");
  QWhatsThis::add(verificar,"");
  QWhatsThis::add(importarLlave,"");
  QWhatsThis::add(exportarLlave,"");
  QWhatsThis::add(activarLlave,"");
  QWhatsThis::add(copy,"");
  QWhatsThis::add(cut,"");
  QWhatsThis::add(paste,"");
  QWhatsThis::add(open,"");
  QWhatsThis::add(saveAll,"");
  QWhatsThis::add(limpiar,"");
  QWhatsThis::add(nuevoGrupo,"");
  QWhatsThis::add(borrarGrupo,"");
  QWhatsThis::add(agregarLlaveGrupo,"");
  QWhatsThis::add(borrarLlaveGrupo,"");	
	
	connect(versionPGP,  SIGNAL(activated(int)),this,SLOT(slotCambioVersion(int)));
	connect(llaveDefault,SIGNAL(activated(int)),this,SLOT(slotCambioLlaveDefault(int)));
}

void KPGPCrypt::initDoc()
{
   doc=new KPGPCryptDoc();
}

void KPGPCrypt::initStatusBar()
{
  ///////////////////////////////////////////////////////////////////
  //STATUSBAR
  statusBar()->message(IDS_STATUS_DEFAULT, 2000);

 	BarraDeProgreso = new QProgressBar(statusBar(),"");
	BarraDeProgreso->setProgress(0);					
	BarraDeProgreso->setGeometry(width(),5,200,15);
}

void KPGPCrypt::initView()
{ 
  ////////////////////////////////////////////////////////////////////
  // set the main widget here
  view=new KPGPCryptView(this, doc);
  setCentralWidget(view);
}

bool KPGPCrypt::queryExit()
{
  int exit=QMessageBox::information(this, "Quit...",
                                    "Do your really want to quit?",
                                    QMessageBox::Ok, QMessageBox::Cancel);

  if (exit==1)
  {

  }
  else
  {

  };

  return (exit==1);
}

/////////////////////////////////////////////////////////////////////
// SLOT IMPLEMENTATION
/////////////////////////////////////////////////////////////////////


void KPGPCrypt::slotViewToolBar()
{
  statusBar()->message("Toggle toolbar...");
  ///////////////////////////////////////////////////////////////////
  // turn Toolbar on or off
  
  if (fileToolbar->isVisible())
  {
    fileToolbar->hide();
    viewMenu->setItemChecked(ID_VIEW_TOOLBAR, false);
  } 
  else
  {
    fileToolbar->show();
    viewMenu->setItemChecked(ID_VIEW_TOOLBAR, true);
  };

  statusBar()->message(IDS_STATUS_DEFAULT);
}

void KPGPCrypt::slotViewStatusBar()
{
  statusBar()->message("Toggle statusbar...");
  ///////////////////////////////////////////////////////////////////
  //turn Statusbar on or off
  
  if (statusBar()->isVisible())
  {
    statusBar()->hide();
    viewMenu->setItemChecked(ID_VIEW_STATUSBAR, false);
  }
  else
  {
    statusBar()->show();
    viewMenu->setItemChecked(ID_VIEW_STATUSBAR, true);
  }
  
  statusBar()->message(IDS_STATUS_DEFAULT);
}

void KPGPCrypt::slotHelpAbout()
{
	KDlgAbout	*dlgAbout = new KDlgAbout();
	dlgAbout->show();
	
}

void KPGPCrypt::slotStatusHelpMsg(const QString &text)
{
  ///////////////////////////////////////////////////////////////////
  // change status message of whole statusbar temporary (text, msec)
  statusBar()->message(text, 2000);
}

void KPGPCrypt::statusCallback(int id_)
{
  switch (id_)
  {
    case ID_FILE_NEW:
         slotStatusHelpMsg("Creates a new document");
         break;

    case ID_FILE_OPEN:
         slotStatusHelpMsg("Opens an existing document");
         break;

    case ID_FILE_SAVE:
         slotStatusHelpMsg("Saves the actual document");
         break;

    case ID_FILE_SAVE_AS:
         slotStatusHelpMsg("Saves the actual document as...");
         break;

    case ID_FILE_CLOSE:
         slotStatusHelpMsg("Closes the actual document");
         break;

    case ID_FILE_PRINT:
         slotStatusHelpMsg("Prints out the actual document");
         break;

    case ID_FILE_QUIT:
         slotStatusHelpMsg("Quits the application");
         break;

    case ID_EDIT_CUT:
         slotStatusHelpMsg("Cuts the selected section and puts it to the clipboard");
         break;

    case ID_EDIT_COPY:
         slotStatusHelpMsg("Copies the selected section to the clipboard");
         break;

    case ID_EDIT_PASTE:
         slotStatusHelpMsg("Pastes the clipboard contents to actual position");
         break;

    case ID_EDIT_SELECT_ALL:
         slotStatusHelpMsg("Selects the whole document contents");
         break;

    case ID_VIEW_TOOLBAR:
         slotStatusHelpMsg("Enables/disables the toolbar");
         break;

    case ID_VIEW_STATUSBAR:
         slotStatusHelpMsg("Enables/disables the statusbar");
         break;

    case ID_HELP_ABOUT:
         slotStatusHelpMsg("Shows an aboutbox");
         break;
  }
}



/******************************************
 *Se encarga de la medida de la ventana   *
 *Cada vez que llega este evento actuali- *
 * za el tamo de los spliters						*
 ******************************************/

void KPGPCrypt::resizeEvent ( QResizeEvent * e )
{
	QMainWindow::resizeEvent (e);
	
	QSize	medida;
	medida = e->size();
	view->split ->resize(medida.width(),medida.height()- 2 * fileToolbar->y()- 30 - 25);
	view->split1->resize(medida.width(),medida.height()- 2 * fileToolbar->y()- 30 - 25);
	BarraDeProgreso->setGeometry(width()-220,5,200,15);

}

/***********************************************
 * Extrae las llaves de los archivos de llaves
 * publicas y privadas para la version 5.00
 * de PGP
 ***********************************************/

void KPGPCrypt::leerLlaves()
{
	FILE							*stream,*Entrada,*Error;
	char							buffer[400];
	int 							i=-1,type=0,k=-1,j;
	int								Cantidad,kk;
	QString						pgp;

	if (operator==(Version(),"PGP 5.00"))	
	{
		pgp = pgpk;
		pgp.operator+=(" -ll");
	 	pipe_pgp(pgp,&Entrada,&stream,&Error);

  	statusBar()->message("Calculando la cantidad de llaves",1000);
  	
		Cantidad = -1;
		do
		{
			fgets(buffer,400,stream);
			Cantidad++;
		}
		while(!feof(stream));
		fclose(stream);

	  statusBar()->message(IDS_STATUS_DEFAULT, 2000);
				
		BarraDeProgreso->setTotalSteps(Cantidad-1);
		
		fclose(Entrada);
		pipe_pgp(pgp,&Entrada,&stream,&Error);

		ListaLlaves.CantidadDeLlaves=0;
		Cantidad = 0;
		
		if (stream)
		{
			
			fgets(buffer,400,stream);

			while(!feof(stream))
			{
			
				BarraDeProgreso->setProgress(Cantidad);					
				for (kk=0;kk<100000;kk++);
				
  			type=100;
  			if (!strncmp(buffer,"sec ",4) || !strncmp(buffer,"sec+",4))	{type=0;}
  			if (!strncmp(buffer,"pub ",4) || !strncmp(buffer,"pub@",4))	{type=1;}
  			if (!strncmp(buffer,"f16",3) || !strncmp(buffer,"f20",3))		{type=2;}
  			if (!strncmp(buffer,"uid",3)) 				{type=3;}
  			if (!strncmp(buffer,"sig",3)   || !strncmp(buffer,"SIG",3))	{type=4;}
  			if (!strncmp(buffer,"sub",3) )				{type=5;}

  			switch (type)
  			{
	 				case 0:	// Llave secreta
						ListaLlaves.Llaves[i].CantidadUID=k;
						i++;
						k=-1;
						ListaLlaves.Llaves[i].UID[k].CantidadDeFirmas=-1;
						ListaLlaves.Llaves[i].Secreta=TRUE;		
						strcpy(ListaLlaves.Llaves[i].Tipo,&buffer[43]);
						strncpy(ListaLlaves.Llaves[i].Creacion,&buffer[21],10);
						strncpy(ListaLlaves.Llaves[i].Expiracion,&buffer[32],10);
						strncpy(ListaLlaves.Llaves[i].Tamano,&buffer[5],4);
						strncpy(ListaLlaves.Llaves[i].Identificacion,&buffer[10],10);
  					break;

					case 1:	// Llave Publica
						ListaLlaves.Llaves[i].CantidadUID=k;
						i++;
						k=-1;
						ListaLlaves.Llaves[i].UID[k].CantidadDeFirmas=-1;
						if (!strncmp(buffer,"pub@",4))
							ListaLlaves.Llaves[i].Activada=FALSE;		
						else
							ListaLlaves.Llaves[i].Activada=TRUE;		
		
						ListaLlaves.Llaves[i].Secreta=false;		
						strcpy(ListaLlaves.Llaves[i].Tipo,&buffer[43]);
						strncpy(ListaLlaves.Llaves[i].Creacion,&buffer[21],10);
						strncpy(ListaLlaves.Llaves[i].Expiracion,&buffer[32],10);
						strncpy(ListaLlaves.Llaves[i].Tamano,&buffer[5],4);
						strncpy(ListaLlaves.Llaves[i].Identificacion,&buffer[10],10);
						break;	

					case 2:	// Fingerprint
						strcpy(ListaLlaves.Llaves[i].FingerPrint,&buffer[23]);
						break;
					case 3:	// Identificacion de la Llave
						k++;
						ListaLlaves.Llaves[i].UID[k].CantidadDeFirmas=-1;
						if (k==0)
						{
							strcpy(ListaLlaves.Llaves[i].Nombre,&buffer[5]);
							// Elimino el caracter de nueva linea
							ListaLlaves.Llaves[i].Nombre[strlen(ListaLlaves.Llaves[i].Nombre)-1]=0;
						}
      			strcpy(ListaLlaves.Llaves[i].UID[k].UID,&buffer[5]);
						// Elimino el caracter de nueva linea
						ListaLlaves.Llaves[i].UID[k].UID[strlen(ListaLlaves.Llaves[i].UID[k].UID)-1]=0;
						break;
					case 4:	// Firmas de las llaves
						ListaLlaves.Llaves[i].UID[k].CantidadDeFirmas++;
						strcpy(ListaLlaves.Llaves[i].UID[k].Firmas[ListaLlaves.Llaves[i].UID[k].CantidadDeFirmas].IDFirma,&buffer[32]);
						// Elimino el caracter de nueva linea
						ListaLlaves.Llaves[i].UID[k].Firmas[ListaLlaves.Llaves[i].UID[k].CantidadDeFirmas].IDFirma[strlen(ListaLlaves.Llaves[i].UID[k].Firmas[ListaLlaves.Llaves[i].UID[k].CantidadDeFirmas].IDFirma)-1]=0;
						break;
					case 5:
						strncpy(ListaLlaves.Llaves[i].SubLlave.Tipo,&buffer[43],14);
						strncpy(ListaLlaves.Llaves[i].SubLlave.Creacion,&buffer[21],10);
						strncpy(ListaLlaves.Llaves[i].SubLlave.Expiracion,&buffer[32],10);
						strncpy(ListaLlaves.Llaves[i].SubLlave.Tamano,&buffer[5],4);
						strncpy(ListaLlaves.Llaves[i].SubLlave.ID,&buffer[10],10);
						break;
			               }
				 fgets(buffer,400,stream);
				 Cantidad++;
			}
			ListaLlaves.CantidadDeLlaves = i;
			fclose(stream);
		}
		else
		{
			QMessageBox * Msg = new QMessageBox(this,"qqq");
			Msg->setText("Error al abrir el archivo de llaves");
			Msg->show();
		}
	}
	
	else if (operator==(Version(),"PGP 6.51"))
	{
		/******************************************
 		 *	Ahora voy a sacar las llaves secretas *
		 ******************************************/
		
		QString pgp = pgp60;
		pgp.operator+=(" -kvv \"\" ");
		pgp.operator+=(getenv("HOME"));
		pgp.operator+=("/.pgp/secring.skr");
		pipe_pgp(pgp,&Entrada,&stream,&Error);

		if (stream)
		{
			fgets(buffer,400,stream);
			i=-1;
			j=-1;
			while(!feof(stream))
			{	
					   if (!strncmp(buffer,"RSA",3)) type=1;
				else if (!strncmp(buffer,"DSS",3)) type=2;
				else if (!strncmp(buffer," DH",3)) type=3;
				else if (!strncmp(buffer,"sig",3)) type=4;
				else if (!strncmp(buffer,"   ",3)) type=5;
				else type=0;
		
				switch (type)
				{
					// RSA
					case 1:
						i++;
						strncpy(ListaLlaves.Llaves[i].Tipo,buffer,3);
						strncpy(ListaLlaves.Llaves[i].Tamano,&buffer[5],4);
						strncpy(ListaLlaves.Llaves[i].Identificacion,&buffer[15],10);
						strncpy(ListaLlaves.Llaves[i].Nombre,&buffer[37],80);
						strncpy(ListaLlaves.Llaves[i].Expiracion,"----------",10);
						ListaLlaves.Llaves[i].Nombre[strlen(ListaLlaves.Llaves[i].Nombre)-1]=0;

						if ((!strncmp(ListaLlaves.Llaves[i].Nombre,"expires",7))||
								(!strcmp(ListaLlaves.Llaves[i].Nombre,"*** KEY REVOKED ***")))
						{
							if (!strncmp(ListaLlaves.Llaves[i].Nombre,"expires",7))
								strncpy(ListaLlaves.Llaves[i].Expiracion,&buffer[45],10);
							fgets(buffer,400,stream);						
							strncpy(ListaLlaves.Llaves[i].Nombre,&buffer[38],80);
							ListaLlaves.Llaves[i].Nombre[strlen(ListaLlaves.Llaves[i].Nombre)-1]=0;
						}	
						
						if (!strcmp (ListaLlaves.Llaves[i].Nombre,"*** DEFAULT SIGNING KEY ***"))
						{
							fgets(buffer,400,stream);						
							strncpy(ListaLlaves.Llaves[i].Nombre,&buffer[37],80);
							ListaLlaves.Llaves[i].Nombre[strlen(ListaLlaves.Llaves[i].Nombre)-1]=0;
						}
						
						ListaLlaves.Llaves[i].Secreta=true;
						strcpy(ListaLlaves.Llaves[i].UID[0].UID,ListaLlaves.Llaves[i].Nombre);
						ListaLlaves.Llaves[i].CantidadUID = 0;
						// Inicializo el numero de firmas
						ListaLlaves.Llaves[i].UID[ListaLlaves.Llaves[i].CantidadUID].CantidadDeFirmas = -1;
						if (type !=4)
							break;
						// DSS	
					case 2:
						i++;
						strncpy(ListaLlaves.Llaves[i].Tipo,buffer,3);
						strncpy(ListaLlaves.Llaves[i].Tamano,&buffer[5],4);
						strncpy(ListaLlaves.Llaves[i].Identificacion,&buffer[15],10);
						strncpy(ListaLlaves.Llaves[i].Expiracion,"----------",10);
						// Procesa la subllave						
						fgets(buffer,400,stream);						
						strncpy(ListaLlaves.Llaves[i].Nombre,&buffer[37],80);
						ListaLlaves.Llaves[i].Nombre[strlen(ListaLlaves.Llaves[i].Nombre)-1]=0;
						if ((!strncmp(ListaLlaves.Llaves[i].Nombre,"expires",7))||
								(!strcmp(ListaLlaves.Llaves[i].Nombre,"*** KEY REVOKED ***")))
						{
							if (!strncmp(ListaLlaves.Llaves[i].Nombre,"expires",7))
								strncpy(ListaLlaves.Llaves[i].Expiracion,&buffer[45],10);
							fgets(buffer,400,stream);						
							strncpy(ListaLlaves.Llaves[i].Nombre,&buffer[38],80);
							ListaLlaves.Llaves[i].Nombre[strlen(ListaLlaves.Llaves[i].Nombre)-1]=0;
						}	
						
						if (!strcmp (ListaLlaves.Llaves[i].Nombre,"*** DEFAULT SIGNING KEY ***"))
						{
							fgets(buffer,400,stream);						
							strncpy(ListaLlaves.Llaves[i].Nombre,&buffer[37],80);
							ListaLlaves.Llaves[i].Nombre[strlen(ListaLlaves.Llaves[i].Nombre)-1]=0;
						}
						ListaLlaves.Llaves[i].Secreta=true;
						// Establezco el primer UID
						strcpy(ListaLlaves.Llaves[i].UID[0].UID,ListaLlaves.Llaves[i].Nombre);
						ListaLlaves.Llaves[i].CantidadUID = 0;
						// Inicializo el numero de firmas
						ListaLlaves.Llaves[i].UID[ListaLlaves.Llaves[i].CantidadUID].CantidadDeFirmas = -1;
						break;
					// Subllave	
					case 3:
						break;
					// Firma
					case 4:
						// Incremento el numero de firmas
						ListaLlaves.Llaves[i].UID[ListaLlaves.Llaves[i].CantidadUID].CantidadDeFirmas++;						
						strncpy(ListaLlaves.Llaves[i].UID[ListaLlaves.Llaves[i].CantidadUID].Firmas[ListaLlaves.Llaves[i].UID[ListaLlaves.Llaves[i].CantidadUID].CantidadDeFirmas].IDFirma,&buffer[38],80);
						ListaLlaves.Llaves[i].UID[ListaLlaves.Llaves[i].CantidadUID].Firmas[ListaLlaves.Llaves[i].UID[ListaLlaves.Llaves[i].CantidadUID].CantidadDeFirmas].IDFirma[strlen(ListaLlaves.Llaves[i].UID[ListaLlaves.Llaves[i].CantidadUID].Firmas[ListaLlaves.Llaves[i].UID[ListaLlaves.Llaves[i].CantidadUID].CantidadDeFirmas].IDFirma)-1]=0;
						break;
					// UID
					case 5:
						// Incremento el numero de UID
						ListaLlaves.Llaves[i].CantidadUID++;
						strncpy(ListaLlaves.Llaves[i].UID[ListaLlaves.Llaves[i].CantidadUID].UID,&buffer[37],80);
						ListaLlaves.Llaves[i].UID[ListaLlaves.Llaves[i].CantidadUID].UID[strlen(ListaLlaves.Llaves[i].UID[ListaLlaves.Llaves[i].CantidadUID].UID)-1]=0;
						// Inicializo el numero de firmas
						ListaLlaves.Llaves[i].UID[ListaLlaves.Llaves[i].CantidadUID].CantidadDeFirmas = -1;
						break;
				}
				fgets(buffer,400,stream);
			}
		}
	
		fclose(Entrada);
		fclose(stream);
		fclose(Error);		
		
		/******************************************
 		 *	Ahora voy a sacar las llaves publicas *
		 ******************************************/
		pgp = pgp60;
		pgp.operator+=(" -kvv \"\" ");
		pgp.operator+=(getenv("HOME"));
		pgp.operator+=("/.pgp/pubring.pkr");
		pipe_pgp(pgp,&Entrada,&stream,&Error);

		if (stream)
		{
			fgets(buffer,400,stream);
			while(!feof(stream))
			{	
				if (!strncmp(buffer,"RSA",3)) type=1;
				else if (!strncmp(buffer,"DSS",3)) type=2;
				else if (!strncmp(buffer,"sig",3)) type=3;
				else if (!strncmp(buffer," DH",3)) type=4;
				else if (!strncmp(buffer,"   ",3))  type=5;
				else type=0;
		
				switch (type)
				{
					case 1:
						i++;
						strncpy(ListaLlaves.Llaves[i].Tipo,buffer,3);
						strncpy(ListaLlaves.Llaves[i].Tamano,&buffer[5],4);
						strncpy(ListaLlaves.Llaves[i].Identificacion,&buffer[15],10);
						strncpy(ListaLlaves.Llaves[i].Nombre,&buffer[37],80);
						strncpy(ListaLlaves.Llaves[i].Expiracion,"----------",10);
						ListaLlaves.Llaves[i].Nombre[strlen(ListaLlaves.Llaves[i].Nombre)-1]=0;
						if ((!strncmp(ListaLlaves.Llaves[i].Nombre,"expires",7))||
								(!strcmp(ListaLlaves.Llaves[i].Nombre,"*** KEY REVOKED ***")))
						{
							if (!strncmp(ListaLlaves.Llaves[i].Nombre,"expires",7))
								strncpy(ListaLlaves.Llaves[i].Expiracion,&buffer[45],10);
							fgets(buffer,400,stream);						
							strncpy(ListaLlaves.Llaves[i].Nombre,&buffer[38],80);
							ListaLlaves.Llaves[i].Nombre[strlen(ListaLlaves.Llaves[i].Nombre)-1]=0;
						}	
						if (!strcmp (ListaLlaves.Llaves[i].Nombre,"*** DEFAULT SIGNING KEY ***"))
						{
							fgets(buffer,400,stream);						
							strncpy(ListaLlaves.Llaves[i].Nombre,&buffer[37],80);
							ListaLlaves.Llaves[i].Nombre[strlen(ListaLlaves.Llaves[i].Nombre)-1]=0;
						}
						ListaLlaves.Llaves[i].Secreta=false;
						ListaLlaves.Llaves[i].Activada=true;
						strcpy(ListaLlaves.Llaves[i].UID[0].UID,ListaLlaves.Llaves[i].Nombre);
						ListaLlaves.Llaves[i].CantidadUID = 0;
						// Inicializo el numero de firmas
						ListaLlaves.Llaves[i].UID[ListaLlaves.Llaves[i].CantidadUID].CantidadDeFirmas = -1;
						break;
					case 2:
						i++;
						strncpy(ListaLlaves.Llaves[i].Tipo,buffer,3);
						strncpy(ListaLlaves.Llaves[i].Tamano,&buffer[5],4);
						strncpy(ListaLlaves.Llaves[i].Identificacion,&buffer[15],10);
						strncpy(ListaLlaves.Llaves[i].Expiracion,"----------",10);
						
						// Procesa la subllave
						fgets(buffer,400,stream);
								
						strncpy(ListaLlaves.Llaves[i].Nombre,&buffer[37],80);
						ListaLlaves.Llaves[i].Nombre[strlen(ListaLlaves.Llaves[i].Nombre)-1]=0;
						if ((!strncmp(ListaLlaves.Llaves[i].Nombre,"expires",7))||
								(!strcmp(ListaLlaves.Llaves[i].Nombre,"*** KEY REVOKED ***")))
						{
							if (!strncmp(ListaLlaves.Llaves[i].Nombre,"expires",7))
								strncpy(ListaLlaves.Llaves[i].Expiracion,&buffer[45],10);
							fgets(buffer,400,stream);						
							strncpy(ListaLlaves.Llaves[i].Nombre,&buffer[38],80);
							ListaLlaves.Llaves[i].Nombre[strlen(ListaLlaves.Llaves[i].Nombre)-1]=0;
						}	
						if (!strcmp (ListaLlaves.Llaves[i].Nombre,"*** DEFAULT SIGNING KEY ***"))
						{
							fgets(buffer,400,stream);						
							strncpy(ListaLlaves.Llaves[i].Nombre,&buffer[37],80);
							ListaLlaves.Llaves[i].Nombre[strlen(ListaLlaves.Llaves[i].Nombre)-1]=0;
						}
						// Establezco el primer UID
						strcpy(ListaLlaves.Llaves[i].UID[0].UID,ListaLlaves.Llaves[i].Nombre);
						ListaLlaves.Llaves[i].CantidadUID = 0;

						ListaLlaves.Llaves[i].Secreta=false;
						ListaLlaves.Llaves[i].Activada=true;
						// Inicializo el numero de firmas
						ListaLlaves.Llaves[i].UID[ListaLlaves.Llaves[i].CantidadUID].CantidadDeFirmas = -1;
						break;
					case 3:
						// Incremento el numero de firmas
						ListaLlaves.Llaves[i].UID[ListaLlaves.Llaves[i].CantidadUID].CantidadDeFirmas++;						
						strncpy(ListaLlaves.Llaves[i].UID[ListaLlaves.Llaves[i].CantidadUID].Firmas[ListaLlaves.Llaves[i].UID[ListaLlaves.Llaves[i].CantidadUID].CantidadDeFirmas].IDFirma,&buffer[38],80);
						ListaLlaves.Llaves[i].UID[ListaLlaves.Llaves[i].CantidadUID].Firmas[ListaLlaves.Llaves[i].UID[ListaLlaves.Llaves[i].CantidadUID].CantidadDeFirmas].IDFirma[strlen(ListaLlaves.Llaves[i].UID[ListaLlaves.Llaves[i].CantidadUID].Firmas[ListaLlaves.Llaves[i].UID[ListaLlaves.Llaves[i].CantidadUID].CantidadDeFirmas].IDFirma)-1]=0;
						break;
					case 4:
						break;
					case 5:
						// Incremento el numero de UID
						ListaLlaves.Llaves[i].CantidadUID++;
						strncpy(ListaLlaves.Llaves[i].UID[ListaLlaves.Llaves[i].CantidadUID].UID,&buffer[37],80);
						ListaLlaves.Llaves[i].UID[ListaLlaves.Llaves[i].CantidadUID].UID[strlen(ListaLlaves.Llaves[i].UID[ListaLlaves.Llaves[i].CantidadUID].UID)-1]=0;
						// Inicializo el numero del Firmas
						ListaLlaves.Llaves[i].UID[ListaLlaves.Llaves[i].CantidadUID].CantidadDeFirmas = -1;
						break;
				}
				fgets(buffer,400,stream);
			}
		}
		ListaLlaves.CantidadDeLlaves = i;
	}		
	
	/****************************************
	* Obtencion de las llaves para el GNUPG *
	****************************************/
	
	else if (operator==(Version(),"GNUPG 1.00"))
	{
		//************************************		
		//* Obtencion de las llaves privadas *
		//************************************				
		pgp = gpg;
		pgp.operator+=(" --list-secret-keys");
		pipe_pgp(pgp,&Entrada,&stream,&Error);

		int		i=0;
		do
		{
			fgets(buffer,400,stream);
			if (!strncmp(buffer,"sec: ",3))
			{
				buffer[strlen(buffer)-1] = 0;
				strcpy(ListaLlaves.Llaves[i].Nombre,substr(buffer,31,80));
				strcpy(ListaLlaves.Llaves[i].Tamano,substr(buffer,5,4));
				strcpy(ListaLlaves.Llaves[i].Identificacion,substr(buffer,11,8));
				strcpy(ListaLlaves.Llaves[i].Tipo,substr(buffer,9,1));
				strcpy(ListaLlaves.Llaves[i].Creacion,substr(buffer,20,10));
				// strcpy(ListaLlaves.Llaves[i].Expiracion,substr(buffer,20,10));
				ListaLlaves.Llaves[i].Secreta = true;
				i++;
			}
		}
		while(!feof(stream));		
		
		fclose(Entrada);
		fclose(Error);
		fclose(stream);
		
		//************************************		
		//* Obtencion de las llaves publicas *
		//************************************		
		
		pgp = gpg;
		pgp.operator+=(" --list-keys");
		pipe_pgp(pgp,&Entrada,&stream,&Error);

		do
		{
			fgets(buffer,400,stream);
			if (!strncmp(buffer,"pub: ",3))
			{
				buffer[strlen(buffer)-1] = 0;
				strcpy(ListaLlaves.Llaves[i].Nombre,substr(buffer,31,80));
				strcpy(ListaLlaves.Llaves[i].Tamano,substr(buffer,5,4));
				strcpy(ListaLlaves.Llaves[i].Identificacion,substr(buffer,11,8));
				strcpy(ListaLlaves.Llaves[i].Tipo,substr(buffer,9,1));
				strcpy(ListaLlaves.Llaves[i].Creacion,substr(buffer,20,10));
//  			strcpy(ListaLlaves.Llaves[i].Expiracion,substr(buffer,20,10));
				ListaLlaves.Llaves[i].Secreta = false;
				ListaLlaves.Llaves[i].Activada = true;
				i++;
			}
		}
		while(!feof(stream));		
		
		fclose(Entrada);
		fclose(Error);
		fclose(stream);
		
		ListaLlaves.CantidadDeLlaves = i-1;
		
		//**************************************************		
		//* Obtencion de las firmas, las uid y las subkeys *
		//**************************************************		
		
		for (i=0;i <= ListaLlaves.CantidadDeLlaves;i++)
		{
			strcpy(buffer,gpg);
			strcpy(buffer," --list-sigs \"");
			strcat(buffer,ListaLlaves.Llaves[i].Nombre);
			strcat(buffer,"\"");

			pipe_pgp(buffer,&Entrada,&stream,&Error);			

			ListaLlaves.Llaves[i].CantidadUID = 0;				
			do
			{
				// Saco las llaves publicas y las uid
				if ( (!strncmp(buffer,"uid",3)) || (!strncmp(buffer,"pub",3)))
				{
					strcpy(ListaLlaves.Llaves[i].UID[ListaLlaves.Llaves[i].CantidadUID].UID,substr(buffer,31,80));	
					if (ListaLlaves.Llaves[i].CantidadUID != 0)					
						ListaLlaves.Llaves[i].UID[ListaLlaves.Llaves[i].CantidadUID-1].CantidadDeFirmas = j-1;
					j = 0;
					ListaLlaves.Llaves[i].CantidadUID++;

				}
				// Saco las subllaves
				else if (!strncmp(buffer,"sub",3))
				{
					// Aca tengo que sacar la subllaves y salir del loop ya que no me
					// interesan las firmas de la subllave
					break;
				}
				else if (!strncmp(buffer,"sig",3))
				{
					strcpy(ListaLlaves.Llaves[i].UID[ListaLlaves.Llaves[i].CantidadUID-1].Firmas[j].IDFirma,substr(buffer,31,80));
					j++;
				}
				
				fgets(buffer,400,stream);					
				buffer[strlen(buffer)-1] = 0;
			}
			while(!feof(stream));

			ListaLlaves.Llaves[i].CantidadUID--;				
			ListaLlaves.Llaves[i].UID[ListaLlaves.Llaves[i].CantidadUID].CantidadDeFirmas = j-1;
					
			fclose(Entrada);
			fclose(Error);
			fclose(stream);
		}
	}
	BarraDeProgreso->reset();
}

/**  */
void KPGPCrypt::slotGuardarConfig()
{
	view->mlel->GuardarConfigPGP();
}
/**  */
void KPGPCrypt::slotSalir()
{
  int exit=QMessageBox::information(this, "Salir.............",
                                    "Quiere salir del programa?",
                                    QMessageBox::Ok, QMessageBox::Cancel);

  if (exit==1)
  {
    qApp->quit();
  }
}
/**  */
void KPGPCrypt::slotActualizar()
{
  leerLlaves();
	view->tw->LlenarTreeList();	
	view->mlel->mostrarParametros();

}
/*******************************
 * Crea una llave en el anillo *
 * de llaves del PGP           *
 *******************************/
void KPGPCrypt::slotCrearLlave()
{
	QString pgp;
	
	// Si se usa gpg o pgp 6.51 el comando es totalmente inteactivo y
	// no se le pueden pasar parametros por lo que no se
	// necesita el dialog de configuracion
	if (operator==(Version(),"GNUPG 1.00"))		
	{
		pgp = "kvt -no_menubar -no_scrollbar -e ";
		pgp.operator+=(gpg);
		pgp.operator+=(" --gen-key");
		system(pgp);		
		slotActualizar();
		return;
	}
	else if (operator==(Version(),"PGP 6.51")	)
	{
		pgp = "kvt -no_menubar -no_scrollbar -e ";
		pgp.operator+=(pgp60);
		pgp.operator+=(" -kg");
		system(pgp);		
		slotActualizar();
		return;
	}
	
	// Si es alguna version de PGP 5.00 de la creacion se encarga el
	// dialogo de configuracion
	KDlgCreateKey *crearLlave = new KDlgCreateKey();
	crearLlave->exec();
	delete crearLlave;
	slotActualizar();
	return;
}
/*******************************
* Borra una llave en el anillo *
* de llaves del PGP            *
********************************/
void KPGPCrypt::slotBorrarLlave()
{
	char     	comando[400],aux[100];

	if (!((QListView *)(view->tw->currentPage()))->currentItem())	
	{
			QMessageBox::information(this,"Informacin","No se eligi ninguna llave",
                               QMessageBox::Ok);
			return;
	}
	
	
	if (((QListView *)(view->tw->currentPage()))->currentItem()->depth() == 0)	
	{	
				strcpy(aux,((QListView *)(view->tw->currentPage()))->currentItem()->text(0));
				aux[strlen(aux)]=0;
		
		    switch( QMessageBox::warning( this, "Advertencia",
																			"Seguro que quiere borrar esta llave?",
																			"Aceptar", "Cancelar", 0,
																			0, 1 ))
				{
					case 0: // Aceptar
						if (operator==(Version(),"PGP 5.00"))
						{
							strcpy(comando,"kvt -no_menubar -no_scrollbar -e ");
							strcat(comando,pgpk);
							strcat(comando," -r \"");
						}
						else if (operator==(Version(),"PGP 6.51"))
						{
							strcpy(comando,"kvt -no_menubar -no_scrollbar -e ");
							strcat(comando,pgp60);
							strcat(comando," -kr \"");
						}
						else if (operator==(Version(),"GNUPG 1.00"))
						{
							// Me fijo si se quiere borrar una llave Publica
							if (!strcmp(view->tw->tabLabel(view->tw->currentPage()),"&Llaves Publicas"))
							{
								// Me fijo si la llave publica proviene de una secreta existente
								if (!esSecreta(aux))
								{
										strcpy(comando,"kvt -no_menubar -no_scrollbar -e ");
										strcat(comando,gpg);
										strcat(comando," --delete-key \"");
								}
								else
								{
									QMessageBox::information(this,"Informacin","La llave elegida tiene una llave secreta para eliminarla borre la secreta",
											 										 QMessageBox::Ok);
									return;
								}
							}
							// Me fijo si se quiere borrar una llave Secreta
							else if (!strcmp(view->tw->tabLabel(view->tw->currentPage()),"Ll&aves Secretas"))
							{
								strcpy(comando,"kvt -no_menubar -no_scrollbar -e ");
								strcat(comando,gpg);
								strcat(comando," --delete-secret-key \"");
							}
						}
						
						strcat(aux,"\"");
						strcat(comando,aux);
						system(comando);
					  leerLlaves();
						view->tw->LlenarTreeList();
						llenarLlavesDefault();
						break;
					default: // Cancelar
							break;
				}
	}
	else
	{
		QMessageBox * Msg = new QMessageBox(this,"qqq");
		Msg->setText("El Item seleccionado no es una Llave sino una Firma o un ID");
		Msg->show();
	}
	return;
}

/******************************
 * Firma una Llave para darle *
 * confianza.                 *
 ******************************/
void KPGPCrypt::slotFirmarLlave()
{
	char     comando[400],aux[100];
	char		 llaveFirmante[256];

	if (!((QListView *)(view->tw->currentPage()))->currentItem())	
	{
			QMessageBox::information(this,"Informacin","No se eligi ninguna llave",
                               QMessageBox::Ok);
			return;
	}

			
	strcpy(llaveFirmante,llaveDefault->text(llaveDefault->currentItem()));
	
	if (operator==(Version(),"PGP 5.00"))
	{
		strcpy(comando,"kvt -no_menubar -no_scrollbar -e ");
		strcat(comando,pgpk);
		strcat(comando," -s -u \"");
	}
	else if (operator==(Version(),"PGP 6.51"))
	{
		strcpy(comando,"kvt -no_menubar -no_scrollbar -e ");
		strcat(comando,pgp60);
		strcat(comando," -k -s -u \"");
	}
	else if (operator==(Version(),"GNUPG 1.00"))
	{
		strcpy(comando,"kvt -no_menubar -no_scrollbar -e ");
		strcat(comando,gpg);
		strcat(comando," --sign-key -u \"");
	}
	strcat(comando,llaveFirmante);
	strcat(comando,"\" \"");
	
	if ((view->tw->llavesPublicas->currentItem()->depth()==0))	
	{	
		strcpy(aux,view->tw->llavesPublicas->currentItem()->text(0));
		aux[strlen(aux)-1]=0;
		strcat(aux,"\"");
		strcat(comando,aux);
		system(comando);
		slotActualizar();
	}
	else
	{
		QMessageBox * Msg = new QMessageBox(this,"qqq");
		Msg->setText("El Item seleccionado no es una Llave sino una Firma o un ID");
		Msg->show();
	}
	return;
}

/** ********************************
* Exporta una llave desde el PGP a *
* un archivo.                      *
************************************/
void KPGPCrypt::slotExportarLlave()
{
	char		comando[400],aux[100];
	FILE		*Entrada,*Salida,*Error;
	QString	archivo;

	if (!((QListView *)(view->tw->currentPage()))->currentItem())	
	{
			QMessageBox::information(this,"Informacin","No se eligi ninguna llave",
                               QMessageBox::Ok);
			return;
	}
	
	if (((QListView *)(view->tw->currentPage()))->currentItem()->depth() == 0)	
	{	
		archivo = QFileDialog::getSaveFileName(getenv("HOME"),"*.asc",this);

		if (!archivo.isNull())
		{
			if (operator==(Version(),"PGP 5.00"))
			{
				strcpy(comando,pgpk);
				strcat(comando," -xa \"");
			}
			else if (operator==(Version(),"PGP 6.51"))
			{
				strcpy(comando,pgp60);
				strcat(comando," -kxa \"");
			}
			else if (operator==(Version(),"GNUPG 1.00"))
			{
				strcpy(comando,gpg);
				strcat(comando," --export -r \"");
			}
								
			strcpy(aux,((QListView *)(view->tw->currentPage()))->currentItem()->text(0));			
			aux[strlen(aux)]=0;
			
			if (operator==(Version(),"PGP 5.00"))
				strcat(aux,"\" -o ");
			else if (operator==(Version(),"PGP 6.51"))
				strcat(aux,"\" ");
			else if (operator==(Version(),"GNUPG 1.00"))
				strcat(aux,"\" --output ");

			strcat(aux,archivo);
			strcat(comando,aux);
			pipe_pgp(comando,&Entrada,&Salida,&Error);
		}
	}
	else
	{
		QMessageBox * Msg = new QMessageBox(this,"qqq");
		Msg->setText("El Item seleccionado no es una Llave sino una Firma o un ID");
		Msg->show();
	}
	return;
}

/***********************************
* Importa una llave desde el PGP a *
* un archivo.                      *
************************************/
void KPGPCrypt::slotImportarLlave()
{
	char	comando[400];

  QString archivo = QFileDialog::getOpenFileName(getenv("HOME"),"*.asc",this);

  if (!archivo.isNull())
  {
		
		if (operator==(Version(),"PGP 5.00"))
		{
			strcpy(comando,"kvt -no_menubar -no_scrollbar -e ");
			strcat(comando,pgpk);
			strcat(comando," -a \"");
		}
		if (operator==(Version(),"PGP 6.51"))
		{
			strcpy(comando,"kvt -no_menubar -no_scrollbar -e ");
			strcat(comando,pgp60);
			strcat(comando," -ka \"");
		}
		if (operator==(Version(),"GNUPG 1.00"))
		{
			strcpy(comando,"kvt -no_menubar -no_scrollbar -e ");
			strcat(comando,gpg);
			strcat(comando," --import \"");
		}
	
		strcat(comando,archivo);
		strcat(comando,"\"");
		system(comando);
	  leerLlaves();

		view->tw->LlenarTreeList();
	}
}
/**************************************
* Encripta el texto que se encuentra  *
* en el segundo splitter y muestra el *
* resultado en el mismo lugar.        *
***************************************/
void KPGPCrypt::slotEncriptar()
{
	char		Receptores[1024];
	char		comando[2048],buf[255];
	FILE		*Entrada,*Salida,*Error;
	bool		HayError=false;

	QMessageBox * Msg = new QMessageBox(this,"qqq");

	KDlgReceptores *DlgReceptores = new KDlgReceptores(this,"",(char *)Receptores);
	DlgReceptores->show();

	if (strcmp(Receptores,""))
	{
		if (operator==(Version(),"PGP 5.00"))
		{
			strcpy(comando,pgpe);
			strcat(comando," -f +batchmode=1 ");
		}
		else if (operator==(Version(),"PGP 6.51"))
		{
			strcpy(comando,pgp60);
			strcat(comando," -e -f +batchmode ");
		}
		else if (operator==(Version(),"GNUPG 1.00"))
		{
			strcpy(comando,gpg);
			strcat(comando," --encrypt --batch ");
		}
		
		if (view->mler->m_TextMode->isChecked())
			strcat(comando,"-t ");
		if (view->mler->m_ASCII_Armoring->isChecked())
			strcat(comando,"-a ");			

		strcat(comando,Receptores);

		pipe_pgp(comando,&Entrada,&Salida,&Error);
		
		int Cantidad = view->mler->m_Texto->numLines();
		for (int i=0;i<Cantidad;i++)
		{
			strcpy(buf, view->mler->m_Texto->textLine(i));
			fputs(buf,Entrada);
			fprintf(Entrada,"%s\n","");
		}
		fclose(Entrada);

		// Proceso el error
		view->mler->m_Log->clear();
		fgets(buf,254,Error);
		if (Error!=0)
		{
			do
			{
				buf[strlen(buf)-1]=0;
				if (!strcmp(buf,"No valid keys found for any recipients, exiting..."))
				{
					HayError=true;
 	      	Msg->setText("No se han elegido llaves validas como receptores");
					Msg->show();
					break;
				}
  			if (!strcmp(buf,"You must specify at least one recipient for encryption!"))
				{
					HayError=true;
 	      	Msg->setText("Debe especificar por lo menos un receptor");
					Msg->show();
					break;				
				}
				fgets(buf,254,Error);
			}while (!feof(Error));
		}
		
		// Si hay error me voy
		if (HayError)
			return;

		view->mler->m_Texto->clear();

		fgets(buf,254,Salida);
		do
		{
			buf[strlen(buf)-1]=0;
			view->mler->m_Texto->insertLine(buf);
			fgets(buf,254,Salida);
		}while (!feof(Salida));
		
		fclose(Salida);

  	view->mler->estaEncriptado=true;
		view->mler->estaFirmado=false;
	}
}
/*********************************
* Verifica un mensaje ya sea     *
* desencriptandolo o verificando *
* su firma                       *
**********************************/
void KPGPCrypt::slotVerificar()
{
  char			buf[255],passPhrase[100];
	FILE			*Entrada,*Salida,*Error;
	bool			HayError=false;	
	QString		pgp;
	
	QMessageBox * Msg = new QMessageBox(this,"qqq");
		
	// Resuelvo el tema del password
	if (view->mler->estaEncriptado==true)
	{
		setenv("PGPPASSFD", "0", 1);	
		if (operator==(Version(),"GNUPG 1.00"))
		{
			strcpy(buf,gpg);
			strcat(buf," --decrypt --batch --passphrase-fd 0");
		}
		KDlgPassword *DlgPassword = new 	KDlgPassword(this,"",passPhrase);
		DlgPassword->show();
	}
	else
	{
		strcpy(buf,gpg);
		strcat(buf," --verify --batch ");
	}

	if (operator==(Version(),"PGP 5.00"))		
	{
		pgp = pgpv;
		pgp.operator+=(" -f +batchmode=1");
		pipe_pgp(pgp,&Entrada,&Salida,&Error);
	}
	else if (operator==(Version(),"PGP 6.51"))
	{
		pgp = pgp60;
		pgp.operator+=(" -p -f +batchmode ");
		pipe_pgp(pgp,&Entrada,&Salida,&Error);
	}
	else if (operator==(Version(),"GNUPG 1.00"))
		pipe_pgp(buf,&Entrada,&Salida,&Error);
			
				
	if (view->mler->estaEncriptado==true)
	{
	  fprintf(Entrada,"%s\n",passPhrase);
 	}
	int Cantidad = view->mler->m_Texto->numLines();
	for (int i=0;i<Cantidad;i++)
	{
		strcpy(buf,view->mler->m_Texto->textLine(i));
		fputs(buf,Entrada);
		fprintf(Entrada,"%s\n","");
	}
	fclose(Entrada);
		// Proceso el error
	view->mler->m_Log->clear();
	fgets(buf,254,Error);
	QString BuscaError = buf;
	if (Error!=0)
	{
		do
		{
			buf[strlen(buf)-1]=0;
			if ((strcmp(buf,"No files specified.  Using stdin."))&&(strcmp(buf,"")))
			{
				view->mler->m_Log->insertLine(buf);
				HayError=true;
			}
			
			if (!strcmp(buf,"Need a pass phrase to decrypt private key:")||
				 (BuscaError.find("bad passphrase")!=-1))
			{
				HayError=true;
      	Msg->setText("La clave ingresada no es correcta");
				Msg->show();
				return;
			}
			fgets(buf,254,Error);
			BuscaError = buf;
		}while (!feof(Error));
	}
	
	view->mler->m_Texto->clear();

	// Si el mensaje estaba encriptado muestro el
	// resultdo del desencriptado
	
	if (view->mler->estaEncriptado==true)	
	{
		fgets(buf,254,Salida);
		do
		{
			buf[strlen(buf)-1]=0;
			view->mler->m_Texto->insertLine(buf);
			fgets(buf,254,Salida);
		}while (!feof(Salida));
	}

	fclose(Salida);
	if (view->mler->estaEncriptado==true)
		unsetenv("PGPPASSFD");
	
	view->mler->estaEncriptado=false;
	view->mler->estaFirmado=false;
}

/*****************************************
* Firma el contenido del editor de texto *
******************************************/
void KPGPCrypt::slotFirmar()
{
	FILE	*Entrada,*Salida,*Error;
	char	buf[255];
	char	passPhrase[100];
	bool	HayError=false;
	char	LlaveFirmante[255]="dummy";

	QMessageBox * Msg = new QMessageBox(this,"qqq");

	if ((operator==(Version(),"PGP 5.00")) || (operator==(Version(),"PGP 6.51")))
	{
		// Seteo para que laclave vaya por stdin
		setenv("PGPPASSFD", "0", 1);

		strcpy(LlaveFirmante,llaveDefault->text(llaveDefault->currentItem()));
	
		// Pregunto la clave
		KDlgPassword *DlgPassword = new 	KDlgPassword(this,"",passPhrase);
		DlgPassword->show();

		// Si aprete cancelar en la clave
		if (strcmp(passPhrase,""))
		{
			// Armo la sentencia
			
			if (operator==(Version(),"PGP 5.00"))			
			{
				strcpy(buf,pgps);
				strcpy(buf," ");				
			}
			else 	if (operator==(Version(),"PGP 6.51"))
			{
				strcpy(buf,pgp60);
				strcat(buf," -s ");
			}
			if (view->mler->m_TextMode->isChecked())
				strcat(buf,"-t ");
			if (view->mler->m_ASCII_Armoring->isChecked())
				strcat(buf,"-a ");			

			// Le agrego al comando la Llave Firmante			
		  strcat(buf,"-u \"");
			strcat(buf,LlaveFirmante);
	  	strcat(buf,"\" ");

			if (operator==(Version(),"PGP 5.00"))			
				strcat(buf,"-f +batchmode=1");
			else 	if (operator==(Version(),"PGP 6.51"))
				strcat(buf,"-f +batchmode");
			
							
			// Ejecuto la sentencia y le paso la clave
			pipe_pgp(buf,&Entrada,&Salida,&Error);
 			fprintf(Entrada,"%s\n",passPhrase);
			
			// Le paso el texto a procesar
			int Cantidad = view->mler->m_Texto->numLines();
			for (int i=0;i<Cantidad;i++)
			{
				strcpy(buf,view->mler->m_Texto->textLine(i));
				fputs(buf,Entrada);
				fprintf(Entrada,"%s\n","");
			}
			// Finalizo la entrada de datos
			fclose(Entrada);
			
			// Proceso el error
			view->mler->m_Log->clear();
			fgets(buf,254,Error);
			if (Error!=0)
			{
				do
				{
					buf[strlen(buf)-1]=0;
					if ((!strcmp(buf,"Cannot unlock private key")) ||
							(!strcmp(buf,"Error:  Bad pass phrase." )))
					{	
						HayError=true;
    		  	Msg->setText("La contrasea no es correcta.");
						Msg->show();
						break;
					}
  	       if ((!strncmp(buf,"Cannot find a private key for signing:",38)) ||
							(!strcmp(buf,"A secret key is required to make a signature. Signature error")))
					{
						HayError=true;
	    	  	Msg->setText("Eligio una llave publica no una privada");
						Msg->show();
						break;
					}

					fgets(buf,254,Error);
				}while (!feof(Error));
			}
		
			// Si hay error me voy
			if (HayError)
				return;

			// Si no hay error muestro el resultado
			view->mler->m_Texto->clear();
			fgets(buf,254,Salida);
			do
			{
				buf[strlen(buf)-1]=0;
				view->mler->m_Texto->insertLine(buf);
				fgets(buf,254,Salida);
			}while (!feof(Salida));

			// Cierro archivo y velvo todo a su estado actual
			fclose(Salida);
			fclose(Error);
			view->mler->estaEncriptado=false;
			view->mler->estaFirmado=true;
			unsetenv("PGPPASSFD");
		}
	}
	else if (operator==(Version(),"GNUPG 1.00"))	
	{
		strcpy(LlaveFirmante,llaveDefault->text(llaveDefault->currentItem()));
	
		// Pregunto la clave
		KDlgPassword *DlgPassword = new 	KDlgPassword(this,"",passPhrase);
		DlgPassword->show();

		// Si aprete cancelar en la clave
		if (strcmp(passPhrase,""))
		{
			// Armo la sentencia
			
			strcpy(buf,gpg);
			strcat(buf," --sign ");
			
			if (view->mler->m_TextMode->isChecked())
				strcat(buf,"-t ");
			if (view->mler->m_ASCII_Armoring->isChecked())
				strcat(buf,"-a ");			

			// Le agrego al comando la Llave Firmante			
		  strcat(buf,"-u \"");
			strcat(buf,LlaveFirmante);
	  	strcat(buf,"\" ");

			strcat(buf,"--batch --passphrase-fd 0");
		
			// Ejecuto la sentencia y le paso la clave
			pipe_pgp(buf,&Entrada,&Salida,&Error);
 			fprintf(Entrada,"%s\n",passPhrase);
			
			// Le paso el texto a procesar
			int Cantidad = view->mler->m_Texto->numLines();
			for (int i=0;i<Cantidad;i++)
			{
				strcpy(buf,view->mler->m_Texto->textLine(i));
				fputs(buf,Entrada);
				fprintf(Entrada,"%s\n","");
			}
			// Finalizo la entrada de datos
			fclose(Entrada);
			
			// Proceso el error
			view->mler->m_Log->clear();
			fgets(buf,254,Error);
			QString BuscoError = buf;
			if (Error!=0)
			{
				do
				{
					buf[strlen(buf)-1]=0;
					if (BuscoError.find("bad passphrase")!=-1)
					{	
						HayError=true;
    		  	Msg->setText("La contrasea no es correcta.");
						Msg->show();
						break;
					}
					fgets(buf,254,Error);
				}while (!feof(Error));
			}
		
			// Si hay error me voy
			if (HayError)
				return;

			// Si no hay error muestro el resultado
			view->mler->m_Texto->clear();
			fgets(buf,254,Salida);
			do
			{
				buf[strlen(buf)-1]=0;
				view->mler->m_Texto->insertLine(buf);
				fgets(buf,254,Salida);
			}while (!feof(Salida));

			// Cierro archivo y velvo todo a su estado actual
			fclose(Salida);
			fclose(Error);
			view->mler->estaEncriptado=false;
			view->mler->estaFirmado=true;
			unsetenv("PGPPASSFD");
		}
	
	}
}
/************************************
* Corta el texto seleccionado en el *
* editor 														*
*************************************/

void KPGPCrypt::slotCut()
{
	view->mler->m_Texto->cut();
}

/************************************
* Pega el texto del portapapeles en *
* el editor 												*
*************************************/

void KPGPCrypt::slotPaste()
{
	view->mler->m_Texto->paste();
}

/************************************
* Copia el texto seleccionado en el *
* editor 														*
*************************************/

void KPGPCrypt::slotCopy()
{
	view->mler->m_Texto->copy();
}

/*******************
* Limpia el editor *
********************/

void KPGPCrypt::slotLimpiar()
{
	view->mler->m_Texto->clear();
}

/************************
* Abre un archivo en el *
* editor 								*
*************************/

void KPGPCrypt::slotAbrir()
{
	QFileDialog	*aaa;
	QString			NombreArchivo;

	aaa = new QFileDialog();
	NombreArchivo = aaa->getOpenFileName(getenv("HOME"),"*",this);
  delete aaa;

	FILE		*Archivo;
	char    buffer[255];

  if (!NombreArchivo.isNull())
  {
		// Vacio la caja de Texto
		view->mler->m_Texto->clear();

		// Abro el Archivo
		Archivo = fopen(NombreArchivo.operator const char*(),"r");
		// Leo cada linea del archivo
		fgets(buffer,254,Archivo);
		do
		{
			// Le saco el caracter de nueva linea
			buffer[strlen(buffer)-1]=0;
			// Inserto la neva linea en la caja de Texto
			view->mler->m_Texto->insertLine(buffer);
			// Leo cada linea del archivo
			fgets(buffer,254,Archivo);
		}while (!feof(Archivo));

		// Cierro el Archivo
		fclose(Archivo);
  }
}
/***********************************
* Guarda el texto del editor en un *
* archivo 												 *
************************************/

void KPGPCrypt::slotGuardar()
{
	FILE		*Archivo;
	char    buffer[255];
	int			Cantidad,i;

	QString NombreArchivo = QFileDialog::getSaveFileName(getenv("HOME"),"*",this);

  if (!NombreArchivo.isNull())
  {
		// Abro el Archivo
		Archivo = fopen(NombreArchivo.operator const char*(),"w");
		Cantidad = view->mler->m_Texto->numLines();
		for (i=0;i<Cantidad;i++)
		{
			strcpy(buffer,view->mler->m_Texto->textLine(i));
			fputs(buffer,Archivo);
			fputs("\n",Archivo);
		}
		// Cierro el Archivo
		fclose(Archivo);
  }
}

/*********************************
* Guarda la version de PGP en el *
* archivo de configuracion 			 *
**********************************/
void KPGPCrypt::slotCambioVersion(int index)
{
	char		buffer[256];
	char		version[256];
	
	strcpy(buffer,(const char *)getenv("HOME"));
  strcat(buffer,"/.kde/share/apps/kpgpcrypt/kpgpcrypt.rc");
	
	QConfig archivoConfig(buffer);
	archivoConfig.setGroup("Version");
	strcpy(version,versionPGP->text(index));
	archivoConfig.escribirEntrada("PGP",version);

	if (operator==(Version(),"PGP 5.00"))
	{
		pgpMenu->setItemChecked(IDM_PGP500,true );
		pgpMenu->setItemChecked(IDM_PGP651,false);
		pgpMenu->setItemChecked(IDM_GPG100,false);		
		
		// Actualiza las llaves
		leerLlaves();
		
		// Actualiza los parametros		
		view->mlel->borrarParametros();
		view->mlel->LeerConfig500();
		
		// Actualiza los grupos
		view->tw->setTabEnabled(view->tw->Grupos,false);
	}
	else if (operator==(Version(),"PGP 6.51"))
	{
		pgpMenu->setItemChecked(IDM_PGP500,false);
		pgpMenu->setItemChecked(IDM_PGP651,true );
		pgpMenu->setItemChecked(IDM_GPG100,false);		
		
		// Actualiza las llaves
		leerLlaves();
		
		// Actualiza los parametros
		view->mlel->borrarParametros();
		view->mlel->LeerConfig651();		

		// Actualiza los grupos
		view->tw->setTabEnabled(view->tw->Grupos,true);
		leerGrupos();
		view->tw->llenarGrupos();
	}
	else if (operator==(Version(),"GNUPG 1.00"))
	{
		pgpMenu->setItemChecked(IDM_PGP500,false);
		pgpMenu->setItemChecked(IDM_PGP651,false);
		pgpMenu->setItemChecked(IDM_GPG100,true );		
	
		// Actualiza las llaves	
		leerLlaves();		
				
		// Borra los parametros		
		view->mlel->borrarParametros();
		view->mlel->cantidadParametros = 0;
		
		// Actualiza los grupos
		view->tw->setTabEnabled(view->tw->Grupos,false);
	}
	
	// Actualiza todas las vistas
	view->tw->LlenarTreeList();
	view->mlel->mostrarParametros();
	llenarLlavesDefault();	

	actualizaBotones();		
	//slotActualizar();	
}

/*****************************************
* Llena el Combo con las llaves Secretas *
* y selecciona la default si en el ini   *
* no esta la default supone que es la    *
* primera                                *
******************************************/
void KPGPCrypt::llenarLlavesDefault()
{
	llaveDefault->clear();

	for (int i = 0;i <= ListaLlaves.CantidadDeLlaves;i++)
	{
		if (ListaLlaves.Llaves[i].Secreta)
		{
			llaveDefault->insertItem(ListaLlaves.Llaves[i].Nombre);
		}
	}
}
/**************************************
* Se llama cuando cambia la seleccion *
* del combobox                        *
***************************************/
void KPGPCrypt::slotCambioLlaveDefault(int index)
{
	char		buffer[256];
	char		llave[256];
	
	strcpy(buffer,(const char *)getenv("HOME"));
  strcat(buffer,"/.kde/share/apps/kpgpcrypt/kpgpcrypt.rc");
	
	QConfig archivoConfig(buffer);
	archivoConfig.setGroup("Llave Firmante");
	strcpy(llave,llaveDefault->text(index));
	archivoConfig.escribirEntrada("Llave",llave);

}
/** ***************************
* Devuelve la version del PGP *
*******************************/
QString KPGPCrypt::Version()
{
	return versionPGP->text(versionPGP->currentItem());
}
/** *************************
* Devuelve la llave default *
*****************************/
QString KPGPCrypt::llave()
{
	return llaveDefault->text(llaveDefault->currentItem());
}

/***********************************
* Inicializa los datos del Pograma *
************************************/
void KPGPCrypt::initDatos()
{
	char		buffer[256];
	int			i;

  // Guardo la version del kpgpcrypt
	strcpy(buffer,getenv("HOME"));
  strcat(buffer,"/.kde/share/apps/kpgpcrypt/kpgpcrypt.rc");
  QConfig archivoConfig(buffer);
	
	archivoConfig.setGroup("Version");
	archivoConfig.escribirEntrada("PGPCrypt","2.0.0");

	// Seteo la version en el ComboBox
 	QString version = archivoConfig.leerEntrada("PGP");
 	for (i = 0;i < versionPGP->count();i++)
 	{
		pgpMenu->setItemChecked(i,false);
	  if (version.isNull())
		{
			versionPGP->setCurrentItem(0);
 			break;
    }
 		if(operator==(version,versionPGP->text(i)))
 		{
 			versionPGP->setCurrentItem(i);
 			pgpMenu->setItemChecked(i,true);
 			break;
		}
 	}
 	 	
	archivoConfig.setGroup("Ejecutables");
 	if (!(pgpe = archivoConfig.leerEntrada("PGP500_Encriptado")))
	pgpe = "pgpe";
 	 	if (!(pgps = archivoConfig.leerEntrada("PGP500_Firmado")))
 		pgps = "pgps"; 	
 	if (!(pgpk = archivoConfig.leerEntrada("PGP500_Llaves")))
 		pgpk = "pgpk";
  if (!(pgpv = archivoConfig.leerEntrada("PGP500_Verificacion")))
 		pgpv = "pgpv";
  if (!(pgp60= archivoConfig.leerEntrada("PGP651")))
 		pgp60 = "pgp60";
  if (!(gpg = archivoConfig.leerEntrada("GNUPG 1.00")))
 		gpg  ="gpg";
 	
 	// Lee las Llaves
  leerLlaves();
  leerGrupos();
  // Llena el Combo de la ToolBar
	llenarLlavesDefault();		
	
	// Seteo la llaveFirmate en el ComboBox
	archivoConfig.setGroup("Llave Firmante");
 	QString llave = archivoConfig.leerEntrada("Llave");
 	for (i=0;i < llaveDefault->count();i++)
 	{
	  if (llave.isNull())
		{
			llaveDefault->setCurrentItem(0);
 			break;
    }
 		if(operator==(llave,llaveDefault->text(i)))
 		{
 			llaveDefault->setCurrentItem(i);
 			break;
		}
 	}
	
}
/*************************************
* Lee los grupos definidos en el PGP *
*************************************/
void KPGPCrypt::leerGrupos()
{
	FILE			*stream,*Entrada,*Error;
	char			buffer[400];
	char			Auxiliar[100];
	QString		recortaEspacios,pgp;
	
	//	i es la cantidad de grupos
	//  j es la cantidad de miembros de cada grupo
	int 	i=0,j=0;
	if (operator==(Version(),"PGP 6.51"))	
	{
		pgp = pgp60;
		pgp.operator+=(" -gvv");
  	pipe_pgp(pgp,&Entrada,&stream,&Error);
  	
		do
		{
			fgets(buffer,400,stream);
			if ((buffer[0] == ' ') && (buffer[1] == '>') && (buffer[2] == ' ') && (buffer[0] != '\0'))
			{
				strcpy(Auxiliar,"");
				strncpy(Auxiliar,&buffer[3],20);
				Auxiliar[20] = 0;

				// Le saco los espacios finales				
				recortaEspacios = Auxiliar;
				recortaEspacios = recortaEspacios.stripWhiteSpace();
				strcpy(Auxiliar,recortaEspacios);
			
				ListaGrupos.Grupos[i].Nombre = Auxiliar;
				strncpy(Auxiliar,&buffer[23],80);
				Auxiliar[strlen(Auxiliar)-1] = 0;
				ListaGrupos.Grupos[i].Descripcion = Auxiliar;
				if (i!=0)
					ListaGrupos.Grupos[i-1].CantidadMiembros = j;
				j=0;
				i++;
			}
			else if ((buffer[23] == '0') && (buffer[24] == 'x') && (buffer[0]!='\n'))
			{
				strcpy(Auxiliar,"");
				strncpy(Auxiliar,&buffer[22],80);
				Auxiliar[strlen(Auxiliar)-1] = 0;
				ListaGrupos.Grupos[i-1].Miembros[j] = Auxiliar;
				j++;
			}
		}
		while(!feof(stream));
		
		fclose(Entrada);
		fclose(Error);
		fclose(stream);
		
		ListaGrupos.Grupos[i-1].CantidadMiembros = j;
		ListaGrupos.CantidadGrupos = i;
	}
	else if (operator==(Version(),"GNUPG 1.00"))	
	{
	
	}
}
/**************************************
* Devuelve la subcadena de "Dato" que *
* empieza en "inicial" y dura "largo" *
***************************************/
QString KPGPCrypt::substr(QString Dato,int inicial,int largo)
{
		return Dato.mid(inicial,largo);	
}

/**************************************
* Devuelve verdadero o falso segun la *
* llave sea secreta o publica respec- *
* tivamente                           *
***************************************/
bool KPGPCrypt::esSecreta(char Nombre[255])
{
	for (int i=0;i<ListaLlaves.CantidadDeLlaves;i++)
	{
		if ((ListaLlaves.Llaves[i].Secreta)&&
				(!strcmp(Nombre,ListaLlaves.Llaves[i].Nombre)))
			return true;
	}
	return false;
}

/****************************************
* Actualiza el estado de los botones de *
* la ToolBar													  *
*****************************************/
void KPGPCrypt::actualizaBotones()
{
	if (operator==(Version(),"PGP 5.00"))
	{
		// Apago los botones de grupos
		borrarGrupo->setEnabled(false);
		nuevoGrupo->setEnabled(false);
		agregarLlaveGrupo->setEnabled(false);
		borrarLlaveGrupo->setEnabled(false);
		
	}
	else if (operator==(Version(),"PGP 6.51"))
	{
		// Prendo los botones de grupos
		borrarGrupo->setEnabled(true);
		nuevoGrupo->setEnabled(true);
		agregarLlaveGrupo->setEnabled(true);
		borrarLlaveGrupo->setEnabled(true);

	}
	else if (operator==(Version(),"GNUPG 1.00"))
	{
		// Apago los botones de grupos
		borrarGrupo->setEnabled(false);
		nuevoGrupo->setEnabled(false);
		agregarLlaveGrupo->setEnabled(false);
		borrarLlaveGrupo->setEnabled(false);
	}
	
	view->tw->slotTabSelect("&Llaves Publicas");
}

/*****************************
* Crea un nuevo grupo de PGP *
******************************/
void KPGPCrypt::slotNuevoGrupo()
{
	KDlgGrupos	grupos(NULL,NULL,true);
	
	grupos.show();
}
/************************
* Borra un grupo de PGP *
*************************/
void KPGPCrypt::slotBorrarGrupo()
{
	char 			buffer[255];
	QString 	Auxiliar;

	if (!((QListView *)(view->tw->currentPage()))->currentItem())	
	{
		QMessageBox::information(this,"Informacin","No se eligi ningun grupo",
 		                         QMessageBox::Ok);
		return;
	}

	if (((QListView *)(view->tw->currentPage()))->currentItem()->depth() == 0)	
	{
	  switch( QMessageBox::warning( this, "Advertencia",
								"Seguro que quiere borrar este grupo?",
								"Aceptar", "Cancelar", 0,
								0, 1 ))
		{
			case 0: // Aceptar
			
				strcpy(buffer,"kvt -no_menubar -no_scrollbar -e ");
				strcat(buffer,pgp60);
				strcat(buffer," -gr \"");
				Auxiliar =((QListView *)(view->tw->currentPage()))->currentItem()->text(0);
				Auxiliar = Auxiliar.stripWhiteSpace();
				strcat(buffer,Auxiliar);
				strcat(buffer,"\"");
				system(buffer);
				break;
			case 1:
				return;
		}
	}			
	else
	{
		QMessageBox::information(this,"Informacin","No se eligi ningun grupo",
                             QMessageBox::Ok);
	}
	leerGrupos();
	view->tw->llenarGrupos();
}

/*************************************
* Agrega una llave a un grupo de PGP *
**************************************/
void KPGPCrypt::slotAgregarLlaveGrupo()
{
	if (!((QListView *)(view->tw->currentPage()))->currentItem())	
	{
		QMessageBox::information(this,"Informacin","No se eligi ningun grupo",
 		                         QMessageBox::Ok);
		return;
	}

	KDlgGrupos	grupos(NULL,NULL,false,Ventana->view->tw->Grupos->currentItem()->text(0));
	grupos.show();
}

/** **********************************
* Borra una llave de un grupo de PGP *
**************************************/
void KPGPCrypt::slotBorrarLlaveGrupo()
{
	char 					buffer[255];
	QString 			Auxiliar;
	QListViewItem	*Item;

	if (!((QListView *)(view->tw->currentPage()))->currentItem())	
	{
		QMessageBox::information(this,"Informacin","No se eligi ninguna llave",
   	                         QMessageBox::Ok);
		return;
	}
	
	if (((QListView *)(view->tw->currentPage()))->currentItem()->depth() == 1)	
	{
	  switch( QMessageBox::warning( this, "Advertencia",
								"Seguro que quiere borrar este grupo?",
								"Aceptar", "Cancelar", 0,
								0, 1 ))
		{
			case 0: // Aceptar
				strcpy(buffer,"kvt -no_menubar -no_scrollbar -e ");
				strcat(buffer,pgp60);
				strcat(buffer," -gr \"");
				Item =((QListView *)(view->tw->currentPage()))->currentItem();
				Auxiliar = Item->parent()->text(0);
				Auxiliar = Auxiliar.stripWhiteSpace();
				strcat(buffer,Auxiliar);
				strcat(buffer,"\" \"");
				Auxiliar =((QListView *)(view->tw->currentPage()))->currentItem()->text(1);
				Auxiliar = Auxiliar.stripWhiteSpace();
				strcat(buffer,Auxiliar);
				strcat(buffer,"\"");
				system(buffer);
				break;
			case 1:
				return;
				break;
		}			
	
	}
	else
	{
		QMessageBox::information(this,"Informacin","No se eligi ninguna llave",
                             QMessageBox::Ok);
	}

	leerGrupos();
	view->tw->llenarGrupos();
}

/**************************************
* Cambia el estado de una llave entre *
* activada y desactivada              *
***************************************/
void KPGPCrypt::slotActivarLlave()
{
	char	mandato[1024];
	
	if (!((QListView *)(view->tw->currentPage()))->currentItem())	
	{
			QMessageBox::information(this,"Informacin","No se eligi ninguna llave",
                               QMessageBox::Ok);
			return;
	}

	if (operator==(Version(),"PGP 5.00"))
	{
		strcpy(mandato,"kvt -no_menubar -no_scrollbar -e ");
		strcat(mandato,pgpk);
		strcat(mandato," -d \"");
		strcat(mandato,view->tw->llavesPublicas->currentItem()->text(0));
		strcat(mandato,"\"");
		system(mandato);
	}
	else if (operator==(Version(),"PGP 6.51"))
	{
		strcpy(mandato,"kvt -no_menubar -no_scrollbar -e ");
		strcat(mandato,pgp60);
		strcat(mandato," -k -d \"");
		strcat(mandato,view->tw->llavesPublicas->currentItem()->text(0));
		strcat(mandato,"\"");
		system(mandato);
	}
	else if (operator==(Version(),"GNUPG 1.00"))
	{
	
	}
	leerLlaves();
	view->tw->LlenarTreeList();	
}
/**  */
void KPGPCrypt::slotEncriptarFirmar()
{
	char		Receptores[1024],passPhrase[100];
	char		comando[2048],buf[255];
	FILE		*Entrada,*Salida,*Error;
	bool		HayError=false;
	QString	pgp;

	QMessageBox * Msg = new QMessageBox(this,"qqq");

	KDlgReceptores *DlgReceptores = new KDlgReceptores(this,"",(char *)Receptores);
	DlgReceptores->show();

	// Seteo para que laclave vaya por stdin
	setenv("PGPPASSFD", "0", 1);
	
	// Pregunto la clave
	KDlgPassword *DlgPassword = new 	KDlgPassword(this,"",passPhrase);
	DlgPassword->show();

	// Si aprete cancelar en la clave
	if (strcmp(passPhrase,""))
	{
		if (strcmp(Receptores,""))
		{
			if (operator==(Version(),"PGP 5.00"))
			{
				strcpy(comando,pgpe);
				strcat(comando," -s -f +batchmode=1 ");
			}
			else if (operator==(Version(),"PGP 6.51"))
			{
				strcpy(comando,pgp60);
				strcat(comando," -es -f +batchmode ");
			}
			else if (operator==(Version(),"GNUPG 1.00"))
			{
				strcpy(comando,gpg);
				strcat(comando," -e -s --batch --passphrase-fd 0");
			}
			
			if (view->mler->m_TextMode->isChecked())
				strcat(comando,"-t ");
			if (view->mler->m_ASCII_Armoring->isChecked())
				strcat(comando,"-a ");			

			strcat(comando,Receptores);
		
			strcat(comando,"-u \"");			
			strcat(comando,llaveDefault->currentText());
			strcat(comando,"\"");					
			
			// ejecuto la sentencia y le paso el password			
			pipe_pgp(comando,&Entrada,&Salida,&Error);
			fprintf(Entrada,"%s\n",passPhrase);
 					
			int Cantidad = view->mler->m_Texto->numLines();
			for (int i=0;i<Cantidad;i++)
			{
				strcpy(buf, view->mler->m_Texto->textLine(i));
				fputs(buf,Entrada);
				fprintf(Entrada,"%s\n","");
			}
			
			fclose(Entrada);

			// Proceso el error
			view->mler->m_Log->clear();
			
			fgets(buf,254,Error);
			
			Msg->setText(buf);
			
			QString	BuscaError = buf;
			if (Error!=0)
			{
				do
				{
					buf[strlen(buf)-1]=0;
					
					Msg->setText(buf);
					
					if (!strcmp(buf,"No valid keys found for any recipients, exiting..."))
					{
						HayError=true;
 	      		Msg->setText("No se han elegido llaves validas como receptores");
						Msg->show();
						break;
					}
  				if (!strcmp(buf,"You must specify at least one recipient for encryption!"))
					{
						HayError=true;
 	      		Msg->setText("Debe especificar por lo menos un receptor");
						Msg->show();
						break;				
					}
					if ((BuscaError.find("Bad pass phrase",0,false)!=-1)||
						  (BuscaError.find("bad passphrase")!=-1))
					{
						HayError=true;
 	      		Msg->setText("La contrasea no es correcta");
						Msg->show();
						break;				
					}
					fgets(buf,254,Error);
					BuscaError = buf;
				}while (!feof(Error));
			}
		
			// Si hay error me voy
			if (HayError)
				return;

			view->mler->m_Texto->clear();

			fgets(buf,254,Salida);
			do
			{
				buf[strlen(buf)-1]=0;
				view->mler->m_Texto->insertLine(buf);
				fgets(buf,254,Salida);
			}while (!feof(Salida));
		
			fclose(Salida);

  		view->mler->estaEncriptado = true;
			view->mler->estaFirmado    = true;
		}
	}
	unsetenv("PGPPASSFD");
}
/************************************
 * Trae llaves desde un servidor de *
 * internet												  *
 ************************************/
void KPGPCrypt::slotTraerLlave()
{
	KKeyServer	keyServer;
	keyServer.show();
	slotActualizar();
}
/**  */
void KPGPCrypt::slotHelp()
{
	KDlgHelp *dlgHelp = new KDlgHelp();
	dlgHelp->show();
}
/**  */
void KPGPCrypt::slotPGP500Menu()
{
			versionPGP->setCurrentItem(IDM_PGP500);
			slotCambioVersion(IDM_PGP500);
}
/**  */
void KPGPCrypt::slotPGP651Menu()
{
			versionPGP->setCurrentItem(IDM_PGP651);
			slotCambioVersion(IDM_PGP651);			
}
/**  */
void KPGPCrypt::slotGPG100Menu()
{
			versionPGP->setCurrentItem(IDM_GPG100);
			slotCambioVersion(IDM_GPG100);			
}
/**  */
void KPGPCrypt::slotConfig()
{
	KConfigDlg	configDlg;
	configDlg.show();
}
