/***************************************************************************
                          kpgpcrypt.h  -  description
                             -------------------
    begin                : Sat Mar 18 15:48:07 ART 2000
    copyright            : (C) 2000 by Christian Rossi
    email                : crossi@mailcity.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef KPGPCRYPT_H
#define KPGPCRYPT_H

// include files for QT
#include <qstring.h>
#include <qpopupmenu.h>
#include <qmainwindow.h>
#include <qaccel.h>
#include <qmenubar.h>
#include <qtoolbar.h>
#include <qpixmap.h>
#include <qtoolbutton.h>
#include <qapp.h>
#include <qstatusbar.h>
#include <qwhatsthis.h>
#include <qmsgbox.h>
#include <qfiledialog.h>
#include <qprinter.h>
#include <qpainter.h>

#include <kprogress.h>

// application specific includes
#include "kpgpcryptview.h"
#include "kpgpcryptdoc.h"
#include "kllaves.h"
#include "kgrupos.h"
#include "resource.h"
#include <qprogressbar.h>

#define		IDM_PGP500	0
#define		IDM_PGP651	1
#define		IDM_GPG100	2

/**
  * This Class is the base class for your application. It sets up the main
  * window and providing a menubar, toolbar
  * and statusbar. For the main view, an instance of class KPGPCryptView is
  * created which creates your view.
  */
class KPGPCrypt : public QMainWindow
{
  Q_OBJECT
  
  public:
    /** construtor */
    KPGPCrypt();
    /** destructor */
    ~KPGPCrypt();
    /** initMenuBar creates the menu_bar and inserts the menuitems */
    void initMenuBar();
    /** this creates the toolbars. Change the toobar look and add new toolbars in this
     * function */
    void initToolBar();
    /** setup the statusbar */

    /** setup the document*/
    void initDoc();
    /** setup the mainview*/
    void initView();
  
    /** overloaded for Message box on last window exit */
    bool queryExit();
	  /**  */
  	void llenarLlavesDefault();
	  /****************************
		* Devuelve la llave default *
		*****************************/
  	QString llave();
	  /******************************
		* Devuelve la version del PGP *
		*******************************/
  	QString Version();
	  /**  */
  	void initDatos();;
		/**************************************
		* Devuelve la subcadena de "Dato" que *
		* empieza en "inicial" y dura "largo" *
		***************************************/
	  QString substr(QString Dato,int inicial,int largo);
	  /**  */
  	void initStatusBar();
	  /**************************************
		* Devuelve verdadero o falso segun la
		* llave sea secreta o publica respec-
		* tivamente
		***************************************/
  	bool esSecreta(char Nombre[255]);
	  /****************************************
		* Actualiza el estado de los botones de
		* la ToolBar
		*****************************************/
	  void actualizaBotones();

  public slots:
  
    /** switch argument for Statusbar help entries on slot selection */
    void statusCallback(int id_);
    /** toggle the toolbar*/
    void slotViewToolBar();
    /** toggle the statusbar*/
    void slotViewStatusBar();
	  /** shows an about dlg*/
    void slotHelpAbout();
    /** change the status message of the whole statusbar temporary */
    void slotStatusHelpMsg(const QString &text);

  /******************************************
  * Se encarga de la medida de la ventana   *
	* Cada vez que llega este evento actuali- *
  * za el tamo de los spliters 						*
  *******************************************/
  void resizeEvent ( QResizeEvent * e );
  /**  */
  void leerLlaves();
  /**  */
  void slotSalir();
  /**  */
  void slotGuardarConfig();
  /**  */
  void slotActualizar();
  /********************************
   * Borra una llave en el anillo *
   * de llaves del PGP            *
   ********************************/
  void slotBorrarLlave();
  /** ****************************
   * Crea una llave en el anillo *
   * de llaves del PGP           *
   *******************************/
  void slotCrearLlave();
  /*****************************
	* Firma una Llave para darle *
	* confianza.                 *
	******************************/
  void slotFirmarLlave();
  /***********************************
  * Importa una llave desde el PGP a *
  * un archivo.                      *
  ************************************/
  void slotImportarLlave();
  /** ********************************
	* Exporta una llave desde el PGP a *
	* un archivo.                      *
	************************************/
  void slotExportarLlave();
  /**************************************
	* Encripta el texto que se encuentra  *
	* en el segundo splitter y muestra el *
	* resultado en el mismo lugar.        *
	***************************************/
  void slotEncriptar();
  /** ******************************
	* Verifica un mensaje ya sea     *
	* desencriptandolo o verificando *
	* su firma                       *
	**********************************/
  void slotVerificar();
  /** **************************************
	* Firma el contenido del editor de texto *
	******************************************/
  void slotFirmar();
  /************************************
	* Corta el texto seleccionado en el *
	* editor 														*
	*************************************/
	  void slotCut();
  /************************************
	* Pega el texto del portapapeles en *
	* el editor 												*
	*************************************/
  void slotCopy();
	/************************************
	* Copia el texto seleccionado en el *
	* editor 														*
	*************************************/
  void slotPaste();
	/*******************
	* Limpia el editor *
	********************/
  void slotLimpiar();
	/************************
	* Abre un archivo en el *
	* editor 								*
	*************************/
  void slotAbrir();
	/***********************************
	* Guarda el texto del editor en un *
	* archivo 												 *
	************************************/
  void slotGuardar();
	/*********************************
	* Guarda la version de PGP en el *
	* archivo de configuracion 			 *
	**********************************/
  void slotCambioVersion(int);
  /**************************************
  * Se llama cuando cambia la seleccion *
  * del combobox                        *
  ***************************************/
  void slotCambioLlaveDefault(int index);
  /*************************************
   * Lee los grupos definidos en el PGP *
   **************************************/
  void leerGrupos();
  /*****************************
	* Crea un nuevo grupo de PGP *
	******************************/
  void slotNuevoGrupo();
  /*************************************
	* Borra una llave de un grupo de PGP *
	**************************************/
  void slotBorrarLlaveGrupo();
  /*************************************
	* Agrega una llave a un grupo de PGP *
	**************************************/
  void slotAgregarLlaveGrupo();
  /************************
	* Borra un grupo de PGP *
	*************************/
  void slotBorrarGrupo();
  /**************************************
	* Cambia el estado de una llave entre *
	* activada y desactivada							*
	***************************************/
  void slotActivarLlave();
  /**  */
  void slotEncriptarFirmar();
  /** *****************************************
* Trae llaves desde un servidor de  *
*  internet
***************************************** */
  void slotTraerLlave();
  /**  */
  void slotHelp();
  /**  */
  void slotGPG100Menu();
  /**  */
  void slotPGP651Menu();
  /**  */
  void slotPGP500Menu();
  /**  */
  void slotConfig();
private:
  /** file_menu contains all items of the menubar entry "File" */
  QPopupMenu *fileMenu;
  /** edit_menu contains all items of the menubar entry "Edit" */
  QPopupMenu *editMenu;
  /** view_menu contains all items of the menubar entry "View" */
  QPopupMenu *viewMenu;
  /** keys_menu contains all items of the menubar entry "llaves" */
  QPopupMenu *keysMenu;
  /** message_menu contains all items of the menubar entry "Mensages" */
	QPopupMenu *messagesMenu;
  /** pgp_menu contains all items of the menubar entry "PGP" */
	QPopupMenu *pgpMenu;

  /** view_menu contains all items of the menubar entry "Help" */
  QPopupMenu *helpMenu;

  QToolBar *fileToolbar;

public: // Public attributes
  /** view is the main widget which represents your working area. The View
  * class should handle all events of the view widget.  It is kept empty so
  * you can create your view according to your application's needs by
  * changing the view class.
  */
  KPGPCryptView *view;
  /** doc represents your actual document and is created only once. It keeps
   * information such as filename and does the serialization of your files.
  */
  KPGPCryptDoc *doc;
	/*********************************
	*Lista de Llaves leidas del PGP  *
	**********************************/
	KLlaves ListaLlaves;
	/*********************************
	*Lista de Grupos leidas del PGP  *
	**********************************/
	KGrupos ListaGrupos;
  /**  */
	QComboBox *versionPGP;
	/**  */
	QComboBox *llaveDefault;
  /**  */
  QToolButton *borrarGrupo;
	/**  */
	QToolButton *nuevoGrupo;
	/**  */
	QToolButton *agregarLlaveGrupo;
	/**  */	
	QToolButton *borrarLlaveGrupo;
	/**  */	
	QToolButton *firmarLlave;
	/**  */		
	QToolButton *crearLlave;
	/**  */		
	QToolButton *borrarLlave;
	/**  */		
	QToolButton *importarLlave;
	/**  */		
	QToolButton *activarLlave;
	/**  */		
	QToolButton *exportarLlave;
	/**  */		
	QToolButton *traerLlave;
  /**  */
  QProgressBar	*BarraDeProgreso;
  /**  */
  QString pgps;
  /**  */
  QString pgpe;
  /**  */
  QString pgpv;
  /**  */
  QString pgpk;
  /**  */
  QString pgp60;
  /**  */
  QString gpg;
};
#endif 


