/***************************************************************************
                          ktabwidget.cpp  -  description
                             -------------------
    begin                : Sat Mar 18 2000
    copyright            : (C) 2000 by Christian Rossi
    email                : crossi@mailcity.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
/***************************************************************************
                          ktabwidget.cpp  -  description
                             -------------------
    begin                : Mon Mar 13 2000
    copyright            : (C) 2000 by Christian Rossi
    email                : crossi@mailcity.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "ktabwidget.h"
#include "kpgpcrypt.h"
#include "qmessagebox.h"
#include "qlistview.h"
#include <qiconset.h>
#include "stdlib.h"

extern KPGPCrypt	*Ventana;

KTabWidget::KTabWidget(QWidget *parent, const char *name ) : QTabWidget(parent,name)
{
	QString base = getenv("HOME");
	QString path = base +"/.kpgpcrypt/icons/kpgpk-public-v.xpm";
	QPixmap	pixmap0(path);
	path = base +"/.kpgpcrypt/icons/kpgpk-secreta-v.xpm";
	QPixmap	pixmap1(path);
	path = base +"/.kpgpcrypt/icons/grupos.xpm";
	QPixmap	pixmap2(path);
	
	llavesPublicas = new QListView (this);	
	llavesSecretas = new QListView (this);	
	Grupos = 				 new QListView (this);	
	
	llavesPublicas->setAllColumnsShowFocus(true);
	llavesSecretas->setAllColumnsShowFocus(true);
	Grupos->setAllColumnsShowFocus(true);

	QIconSet IconoPublico(pixmap0);
	addTab(llavesPublicas,IconoPublico,"&Llaves Publicas");
	QIconSet IconoSecreto(pixmap1);
	addTab(llavesSecretas,IconoSecreto,"Ll&aves Secretas");
	QIconSet IconoGrupos(pixmap2);
	addTab(Grupos,IconoGrupos,"&Grupos");

	llavesPublicas->setRootIsDecorated(true);
	llavesSecretas->setRootIsDecorated(true);
	Grupos->setRootIsDecorated(true);
		
	llavesPublicas->addColumn("Nombre",-1);
	llavesPublicas->addColumn("Tipo",-1);
	llavesPublicas->addColumn("Tamao",-1);
	llavesPublicas->addColumn("ID",-1);
	llavesPublicas->addColumn("Validez",-1);
	llavesPublicas->addColumn("Expira",-1);

	llavesSecretas->addColumn("Nombre",-1);
	llavesSecretas->addColumn("Tipo",-1);
	llavesSecretas->addColumn("Tamao",-1);
	llavesSecretas->addColumn("ID",-1);
	llavesSecretas->addColumn("Validez",-1);
	llavesSecretas->addColumn("Expira",-1);

	Grupos->addColumn("Grupo",-1);
	Grupos->addColumn("Descripcion del Grupo",-1);
		
	if (operator==(Ventana->Version(),"PGP 6.51"))
	{
		llenarGrupos();
		setTabEnabled(Grupos,true);
	}
	if (operator==(Ventana->Version(),"PGP 5.00"))
		setTabEnabled(Grupos,false);
	if (operator==(Ventana->Version(),"GNUPG 1.00"))
		setTabEnabled(Grupos,false);
		
	LlenarTreeList();

	connect(this,SIGNAL(selected( const QString &)),this,SLOT( slotTabSelect(const QString &)));
}

KTabWidget::~KTabWidget(){
}

/*******************************************
 * Llena la lista de llaves con las llaves *
 * publicas y con las secretas             *
 *******************************************/
void KTabWidget::LlenarTreeList()
{
	QListViewItem *Item=0;
	QListViewItem *Hijo,*xFirma;
	char					Auxi[4],buffer[255],icono[255];
	
	llavesSecretas->clear();
	llavesPublicas->clear();	
						
	strcpy(buffer,getenv("KDEDIR"));
	strcat(buffer,"/share/icons/");

	strcpy(icono,buffer);
	strcat(icono,"kpgpk-public-v.xpm");
	QPixmap *PublicaActivada = new QPixmap (icono);
	strcpy(icono,buffer);
	strcat(icono,"kpgpk-secreta-v.xpm");
	QPixmap *SecretaActivada = new QPixmap (icono);
	strcpy(icono,buffer);
	strcat(icono,"kpgpk-public-x.xpm");
	QPixmap *PublicaDesactivada = new QPixmap (icono);
	strcpy(icono,buffer);
	strcat(icono,"kpgpk-sign.xpm");
	QPixmap *Firma = new QPixmap (icono);
	strcpy(icono,buffer);
	strcat(icono,"kpgpk-trust-ultimate.xpm");
	QPixmap *ConfianzaUltimate = new QPixmap (icono);
	strcpy(icono,buffer);
	strcat(icono,"kpgpk-trust-null.xpm");
	QPixmap *ConfianzaNula = new QPixmap (icono);
	strcpy(icono,buffer);
	strcat(icono,"kpgpk-invalida.xpm");
	QPixmap *Valida = new QPixmap (icono);
	strcpy(icono,buffer);
	strcat(icono,"kpgpk-valida.xpm");
	QPixmap *Invalida = new QPixmap (icono);
	strcpy(icono,buffer);
	strcat(icono,"kpgpk-email.xpm");
	QPixmap *email = new QPixmap (icono);

	for (int i = 0;i <= Ventana->ListaLlaves.CantidadDeLlaves;i++)
	{
		{
			strncpy(Auxi,Ventana->ListaLlaves.Llaves[i].Tipo,3);
			Auxi[3]=0;

			if (!Ventana->ListaLlaves.Llaves[i].Secreta)			
				Item = new QListViewItem(llavesPublicas,Ventana->ListaLlaves.Llaves[i].Nombre,
			   			 Auxi,Ventana->ListaLlaves.Llaves[i].Tamano,Ventana->ListaLlaves.Llaves[i].Identificacion,"",Ventana->ListaLlaves.Llaves[i].Expiracion);
			else												   			
				Item = new QListViewItem(llavesSecretas,Ventana->ListaLlaves.Llaves[i].Nombre,
			   			 Auxi,Ventana->ListaLlaves.Llaves[i].Tamano,Ventana->ListaLlaves.Llaves[i].Identificacion,"",Ventana->ListaLlaves.Llaves[i].Expiracion);
			
			if (Ventana->ListaLlaves.Llaves[i].Secreta)
			{	
				Item->setPixmap(0,*SecretaActivada);
			 }
			else	
			{
				if (Ventana->ListaLlaves.Llaves[i].Activada)
					Item->setPixmap(0,*PublicaActivada);
				else	
					Item->setPixmap(0,*PublicaDesactivada);
      }

			if (!strcmp(Ventana->ListaLlaves.Llaves[i].Confianza,"untrusted"))
			{	
				Item->setPixmap(3,*ConfianzaNula);
			}
			if (!strncmp(Ventana->ListaLlaves.Llaves[i].Confianza,"ultimate",8))
			{	
				Item->setPixmap(3,*ConfianzaUltimate);
			}		

			if (!strcmp(Ventana->ListaLlaves.Llaves[i].Validez,"complete"))
			{	
				Item->setPixmap(4,*Invalida);
			}
			if (!strncmp(Ventana->ListaLlaves.Llaves[i].Validez,"invalid",7))
			{	
				Item->setPixmap(4,*Valida);
			}		

			for (int j = 0;j<=Ventana->ListaLlaves.Llaves[i].CantidadUID;j++)
			{
				Hijo = new QListViewItem(Item,Ventana->ListaLlaves.Llaves[i].UID[j].UID,"","","","","");
				Hijo->setPixmap(0,*email);
				for (int k = 0;k<=Ventana->ListaLlaves.Llaves[i].UID[j].CantidadDeFirmas;k++)
				{
					xFirma = new QListViewItem(Hijo,Ventana->ListaLlaves.Llaves[i].UID[j].Firmas[k].IDFirma,"","","","","");
					xFirma->setPixmap(0,*Firma);
				}
			}
		}
	}
	llavesPublicas->repaint();
	llavesSecretas->repaint();
}

/**  */
void KTabWidget::slotTabSelect( const QString & tabLabel)
{
	if(tabLabel == "&Llaves Publicas")
	{
		// Apago los botones de grupos
		Ventana->borrarGrupo->setEnabled(false);
		Ventana->nuevoGrupo->setEnabled(false);
		Ventana->agregarLlaveGrupo->setEnabled(false);
		Ventana->borrarLlaveGrupo->setEnabled(false);
		Ventana->crearLlave->setEnabled(true);
		Ventana->firmarLlave->setEnabled(true);				
		Ventana->borrarLlave->setEnabled(true);
		Ventana->importarLlave->setEnabled(true);
		Ventana->activarLlave->setEnabled(true);
		Ventana->exportarLlave->setEnabled(true);
		Ventana->firmarLlave->setEnabled(true);
	}
	else 	if(tabLabel == "Ll&aves Secretas")
	{
		// Apago los botones de grupos
		Ventana->borrarGrupo->setEnabled(false);
		Ventana->nuevoGrupo->setEnabled(false);
		Ventana->agregarLlaveGrupo->setEnabled(false);
		Ventana->borrarLlaveGrupo->setEnabled(false);
		Ventana->crearLlave->setEnabled(true);
		Ventana->firmarLlave->setEnabled(true);				
		Ventana->borrarLlave->setEnabled(true);
		Ventana->importarLlave->setEnabled(true);
		Ventana->activarLlave->setEnabled(false);
		Ventana->exportarLlave->setEnabled(true);
		Ventana->firmarLlave->setEnabled(false);
	}
	else
	{
		// Prendo los botones de grupos
		Ventana->borrarGrupo->setEnabled(true);
		Ventana->nuevoGrupo->setEnabled(true);
		Ventana->agregarLlaveGrupo->setEnabled(true);
		Ventana->borrarLlaveGrupo->setEnabled(true);
		Ventana->crearLlave->setEnabled(false);
		Ventana->firmarLlave->setEnabled(false);		
		Ventana->borrarLlave->setEnabled(false);
		Ventana->importarLlave->setEnabled(false);
		Ventana->activarLlave->setEnabled(false);
		Ventana->exportarLlave->setEnabled(false);
	}
}

/******************************
* Llena el TreeList de Grupos *
*******************************/
void KTabWidget::llenarGrupos()
{
	int 						i,j;
	QListViewItem		*Item,*hijo;
	char						buffer[255],icono[255];
	
	Grupos->clear();
	
	strcpy(buffer,getenv("KDEDIR"));
	strcat(buffer,"/share/icons/");
	
	strcpy(icono,buffer);
	strcat(icono,"kpgpk-email.xpm");
	QPixmap *email = new QPixmap(icono);
	
	strcpy(icono,buffer);
	strcat(icono,"grupos.xpm");
	QPixmap *grupos = new QPixmap(icono);

	for (i=0;i<Ventana->ListaGrupos.CantidadGrupos;i++)
	{
		Item = new QListViewItem(Grupos,Ventana->ListaGrupos.Grupos[i].Nombre,Ventana->ListaGrupos.Grupos[i].Descripcion);
		Item->setPixmap(0,*grupos);
		for (j=0;j < Ventana->ListaGrupos.Grupos[i].CantidadMiembros;j++)
		{
			hijo = new QListViewItem(Item,substr(Ventana->ListaGrupos.Grupos[i].Miembros[j],0,10),
															 substr(Ventana->ListaGrupos.Grupos[i].Miembros[j],12,70));
			hijo->setPixmap(0,*email);
		}
	}
}

/**************************************
* Devuelve la subcadena de "Dato" que *
* empieza en "inicial" y dura "largo" *
***************************************/
QString KTabWidget::substr(QString Dato,int inicial,int largo)
{
		return Dato.mid(inicial,largo);		
}
